using System;
using MT.Tracker.DataStructures;

namespace MT.Tracker
{
	public delegate void NewHypothesisesDelegate(HypothesisSuperSet HS);

	public interface ITracker
	{

		event NewHypothesisesDelegate NewHypothesises;


		#region "Properties"

		int Vmax
		{
			get;
			set;
		}

		int Vmin
		{
			get;
			set; 
		}

		int Vnrm
		{
			get;
			set;
		}

		float GammaMax
		{
			get;
			set;
		}

		float AngleWeight
		{
			get;
			set;
		}

		float SpeedWeight
		{
			get;
			set;
		}

		float StartSpeedWight
		{
			get;
			set;
		}

		bool	 ConfigMode
		{
			get;
			set;
		}

		#endregion	


		bool initialize(FeaturePointFrameColor oldFrame, FeaturePointFrameColor curFrame, FeaturePointFrameColor newFrame);
		bool processDoubleFrame(FeaturePointFrameColor curFrame, FeaturePointFrameColor newFrame);
		bool processFrame(FeaturePointFrameColor oldFrame, FeaturePointFrameColor curFrame, FeaturePointFrameColor newFrame);
		bool postProcessFrame(FeaturePointFrameColor oldFrame);




	}
}