using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using MT.Tracker.DataStructures;

namespace MT.Tracker
{
	/// <summary>
	/// Summary description for frmDebug.
	/// </summary>
	public class frmDebug : System.Windows.Forms.Form
	{
		private System.Windows.Forms.HScrollBar hsbFrame;
		private System.Windows.Forms.TrackBar trbNrOfFrames;
		private System.Windows.Forms.Label lblCurrentFramelbl;
		private System.Windows.Forms.Label lblNrOfFrameslbl;
		private System.Windows.Forms.Label lblCurrentFrame;
		private System.Windows.Forms.Label lblNrOfFrames;
		private System.Windows.Forms.CheckBox ckbMarkCurrentFrame;
		private System.Windows.Forms.CheckBox ckbShowFP;
		private System.Windows.Forms.NumericUpDown nudFPSize;
		private System.Windows.Forms.Label lblSizeOfFP;
		private System.Windows.Forms.CheckBox ckbShowTrajectories; 
		
		private FeaturePointData[] _data;	//Stores all Featurepoint Data
		private int _currentFrame=1;
		private int _nrOfFrames=5;
		private int _intFPSize = 3;
		private bool _blnShowFP = true;
		private bool _blnMarkCurrentFrame = true;
		private bool _blnShowTrajectories = true;
		private bool _blnShowRed = true;
		private bool _blnShowGreen = true;
		private bool _blnShowBlue = true;
		private bool _blnShowCalculated = true;
		private bool _blnShowMeasured = true;
		private bool _blnShowTrajectoryID = true;
		
		private bool _blnUpdating = false;


		private System.Windows.Forms.PictureBox pcbXY;
		private System.Windows.Forms.PictureBox pcbXT;
		private System.Windows.Forms.PictureBox pcbYT;
		private System.Windows.Forms.MenuItem mnuFile;
		private System.Windows.Forms.MenuItem mnuListOpen;
		private System.Windows.Forms.MainMenu mnuMain;
		private System.Windows.Forms.CheckBox ckbShowRed;
		private System.Windows.Forms.CheckBox ckbShowGreen;
		private System.Windows.Forms.CheckBox ckbShowBlue;
		private System.Windows.Forms.CheckBox chkShowCalculated;
		private System.Windows.Forms.CheckBox chkShowMeasured;
		private System.Windows.Forms.CheckBox chkShowTrajectoryID;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmDebug(FeaturePointData Data)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			_data = new FeaturePointData[1] {Data};
			//Actualize all Fields
			SeedData();

		}
		// Todo: Obsolete - replaced by call with camera ID
		public frmDebug(FeaturePointData DataR, FeaturePointData DataG, FeaturePointData DataB)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			//_data = DataR;
			_data = new FeaturePointData[3] {DataR, DataG, DataB};

			//Actualize all Fields
			SeedData();

		}
		public frmDebug(FeaturePointData DataR, FeaturePointData DataG, FeaturePointData DataB, int camID)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			//_data = DataR;
			this.Text = "Kamera " + ((int)camID+1).ToString();
			_data = new FeaturePointData[3] {DataR, DataG, DataB};

			//Actualize all Fields
			SeedData();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.pcbXY = new System.Windows.Forms.PictureBox();
			this.trbNrOfFrames = new System.Windows.Forms.TrackBar();
			this.hsbFrame = new System.Windows.Forms.HScrollBar();
			this.lblCurrentFramelbl = new System.Windows.Forms.Label();
			this.lblNrOfFrameslbl = new System.Windows.Forms.Label();
			this.lblCurrentFrame = new System.Windows.Forms.Label();
			this.lblNrOfFrames = new System.Windows.Forms.Label();
			this.ckbMarkCurrentFrame = new System.Windows.Forms.CheckBox();
			this.ckbShowFP = new System.Windows.Forms.CheckBox();
			this.ckbShowTrajectories = new System.Windows.Forms.CheckBox();
			this.nudFPSize = new System.Windows.Forms.NumericUpDown();
			this.lblSizeOfFP = new System.Windows.Forms.Label();
			this.pcbXT = new System.Windows.Forms.PictureBox();
			this.pcbYT = new System.Windows.Forms.PictureBox();
			this.mnuMain = new System.Windows.Forms.MainMenu();
			this.mnuFile = new System.Windows.Forms.MenuItem();
			this.mnuListOpen = new System.Windows.Forms.MenuItem();
			this.ckbShowRed = new System.Windows.Forms.CheckBox();
			this.ckbShowGreen = new System.Windows.Forms.CheckBox();
			this.ckbShowBlue = new System.Windows.Forms.CheckBox();
			this.chkShowCalculated = new System.Windows.Forms.CheckBox();
			this.chkShowMeasured = new System.Windows.Forms.CheckBox();
			this.chkShowTrajectoryID = new System.Windows.Forms.CheckBox();
			((System.ComponentModel.ISupportInitialize)(this.trbNrOfFrames)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.nudFPSize)).BeginInit();
			this.SuspendLayout();
			// 
			// pcbXY
			// 
			this.pcbXY.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pcbXY.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.pcbXY.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pcbXY.Location = new System.Drawing.Point(573, 7);
			this.pcbXY.Name = "pcbXY";
			this.pcbXY.Size = new System.Drawing.Size(534, 416);
			this.pcbXY.TabIndex = 0;
			this.pcbXY.TabStop = false;
			this.pcbXY.Paint += new System.Windows.Forms.PaintEventHandler(this.pcbViews_Paint);
			// 
			// trbNrOfFrames
			// 
			this.trbNrOfFrames.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.trbNrOfFrames.Location = new System.Drawing.Point(20, 451);
			this.trbNrOfFrames.Maximum = 757;
			this.trbNrOfFrames.Name = "trbNrOfFrames";
			this.trbNrOfFrames.Size = new System.Drawing.Size(547, 50);
			this.trbNrOfFrames.TabIndex = 1;
			this.trbNrOfFrames.Value = 1;
			this.trbNrOfFrames.Scroll += new System.EventHandler(this.trbNrOfFrames_Scroll);
			// 
			// hsbFrame
			// 
			this.hsbFrame.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.hsbFrame.LargeChange = 1;
			this.hsbFrame.Location = new System.Drawing.Point(27, 423);
			this.hsbFrame.Maximum = 756;
			this.hsbFrame.Name = "hsbFrame";
			this.hsbFrame.Size = new System.Drawing.Size(533, 14);
			this.hsbFrame.TabIndex = 2;
			this.hsbFrame.Scroll += new System.Windows.Forms.ScrollEventHandler(this.hsbFrame_Scroll);
			// 
			// lblCurrentFramelbl
			// 
			this.lblCurrentFramelbl.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblCurrentFramelbl.Location = new System.Drawing.Point(27, 499);
			this.lblCurrentFramelbl.Name = "lblCurrentFramelbl";
			this.lblCurrentFramelbl.Size = new System.Drawing.Size(146, 14);
			this.lblCurrentFramelbl.TabIndex = 3;
			this.lblCurrentFramelbl.Text = "Aktuelles Zentralframe:";
			this.lblCurrentFramelbl.Click += new System.EventHandler(this.lblCurrentFramelbl_Click);
			// 
			// lblNrOfFrameslbl
			// 
			this.lblNrOfFrameslbl.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblNrOfFrameslbl.Location = new System.Drawing.Point(27, 555);
			this.lblNrOfFrameslbl.Name = "lblNrOfFrameslbl";
			this.lblNrOfFrameslbl.Size = new System.Drawing.Size(206, 14);
			this.lblNrOfFrameslbl.TabIndex = 4;
			this.lblNrOfFrameslbl.Text = "Anzahl gleichzeitig angezeigter Frames:";
			// 
			// lblCurrentFrame
			// 
			this.lblCurrentFrame.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblCurrentFrame.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblCurrentFrame.Location = new System.Drawing.Point(27, 520);
			this.lblCurrentFrame.Name = "lblCurrentFrame";
			this.lblCurrentFrame.Size = new System.Drawing.Size(133, 21);
			this.lblCurrentFrame.TabIndex = 5;
			this.lblCurrentFrame.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblNrOfFrames
			// 
			this.lblNrOfFrames.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblNrOfFrames.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.lblNrOfFrames.Location = new System.Drawing.Point(27, 575);
			this.lblNrOfFrames.Name = "lblNrOfFrames";
			this.lblNrOfFrames.Size = new System.Drawing.Size(133, 21);
			this.lblNrOfFrames.TabIndex = 6;
			this.lblNrOfFrames.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// ckbMarkCurrentFrame
			// 
			this.ckbMarkCurrentFrame.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ckbMarkCurrentFrame.Location = new System.Drawing.Point(24, 679);
			this.ckbMarkCurrentFrame.Name = "ckbMarkCurrentFrame";
			this.ckbMarkCurrentFrame.Size = new System.Drawing.Size(206, 14);
			this.ckbMarkCurrentFrame.TabIndex = 7;
			this.ckbMarkCurrentFrame.Text = "FP des aktuellen Frames markieren";
			this.ckbMarkCurrentFrame.CheckedChanged += new System.EventHandler(this.ctrl_newValue);
			// 
			// ckbShowFP
			// 
			this.ckbShowFP.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ckbShowFP.Location = new System.Drawing.Point(24, 656);
			this.ckbShowFP.Name = "ckbShowFP";
			this.ckbShowFP.Size = new System.Drawing.Size(206, 14);
			this.ckbShowFP.TabIndex = 8;
			this.ckbShowFP.Text = "Feature Punkte anzeigen";
			this.ckbShowFP.CheckedChanged += new System.EventHandler(this.ctrl_newValue);
			// 
			// ckbShowTrajectories
			// 
			this.ckbShowTrajectories.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ckbShowTrajectories.Location = new System.Drawing.Point(24, 720);
			this.ckbShowTrajectories.Name = "ckbShowTrajectories";
			this.ckbShowTrajectories.Size = new System.Drawing.Size(206, 14);
			this.ckbShowTrajectories.TabIndex = 9;
			this.ckbShowTrajectories.Text = "Trajektorien anzeigen";
			this.ckbShowTrajectories.CheckedChanged += new System.EventHandler(this.ctrl_newValue);
			// 
			// nudFPSize
			// 
			this.nudFPSize.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.nudFPSize.Location = new System.Drawing.Point(27, 617);
			this.nudFPSize.Minimum = new System.Decimal(new int[] {
																	  1,
																	  0,
																	  0,
																	  0});
			this.nudFPSize.Name = "nudFPSize";
			this.nudFPSize.Size = new System.Drawing.Size(66, 20);
			this.nudFPSize.TabIndex = 10;
			this.nudFPSize.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.nudFPSize.Value = new System.Decimal(new int[] {
																	3,
																	0,
																	0,
																	0});
			this.nudFPSize.ValueChanged += new System.EventHandler(this.ctrl_newValue);
			// 
			// lblSizeOfFP
			// 
			this.lblSizeOfFP.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblSizeOfFP.Location = new System.Drawing.Point(27, 603);
			this.lblSizeOfFP.Name = "lblSizeOfFP";
			this.lblSizeOfFP.Size = new System.Drawing.Size(186, 14);
			this.lblSizeOfFP.TabIndex = 11;
			this.lblSizeOfFP.Text = "Grsse der FP:";
			// 
			// pcbXT
			// 
			this.pcbXT.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pcbXT.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.pcbXT.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pcbXT.Location = new System.Drawing.Point(573, 430);
			this.pcbXT.Name = "pcbXT";
			this.pcbXT.Size = new System.Drawing.Size(534, 416);
			this.pcbXT.TabIndex = 12;
			this.pcbXT.TabStop = false;
			this.pcbXT.Paint += new System.Windows.Forms.PaintEventHandler(this.pcbViews_Paint);
			// 
			// pcbYT
			// 
			this.pcbYT.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pcbYT.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.pcbYT.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pcbYT.Location = new System.Drawing.Point(27, 7);
			this.pcbYT.Name = "pcbYT";
			this.pcbYT.Size = new System.Drawing.Size(533, 416);
			this.pcbYT.TabIndex = 13;
			this.pcbYT.TabStop = false;
			this.pcbYT.Paint += new System.Windows.Forms.PaintEventHandler(this.pcbViews_Paint);
			// 
			// mnuMain
			// 
			this.mnuMain.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuFile});
			// 
			// mnuFile
			// 
			this.mnuFile.Index = 0;
			this.mnuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuListOpen});
			this.mnuFile.Text = "&Datei";
			// 
			// mnuListOpen
			// 
			this.mnuListOpen.Index = 0;
			this.mnuListOpen.Text = "&Listen ffnen";
			this.mnuListOpen.Click += new System.EventHandler(this.mnuListOpen_Click);
			// 
			// ckbShowRed
			// 
			this.ckbShowRed.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ckbShowRed.Checked = true;
			this.ckbShowRed.CheckState = System.Windows.Forms.CheckState.Checked;
			this.ckbShowRed.Location = new System.Drawing.Point(352, 504);
			this.ckbShowRed.Name = "ckbShowRed";
			this.ckbShowRed.Size = new System.Drawing.Size(176, 24);
			this.ckbShowRed.TabIndex = 16;
			this.ckbShowRed.Text = "Rote Punkte anzeigen";
			this.ckbShowRed.CheckedChanged += new System.EventHandler(this.ctrl_newValue);
			// 
			// ckbShowGreen
			// 
			this.ckbShowGreen.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ckbShowGreen.Checked = true;
			this.ckbShowGreen.CheckState = System.Windows.Forms.CheckState.Checked;
			this.ckbShowGreen.Location = new System.Drawing.Point(352, 536);
			this.ckbShowGreen.Name = "ckbShowGreen";
			this.ckbShowGreen.Size = new System.Drawing.Size(176, 24);
			this.ckbShowGreen.TabIndex = 17;
			this.ckbShowGreen.Text = "Grne Punkte anzeigen";
			this.ckbShowGreen.CheckedChanged += new System.EventHandler(this.ctrl_newValue);
			// 
			// ckbShowBlue
			// 
			this.ckbShowBlue.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ckbShowBlue.Checked = true;
			this.ckbShowBlue.CheckState = System.Windows.Forms.CheckState.Checked;
			this.ckbShowBlue.Location = new System.Drawing.Point(352, 568);
			this.ckbShowBlue.Name = "ckbShowBlue";
			this.ckbShowBlue.Size = new System.Drawing.Size(176, 24);
			this.ckbShowBlue.TabIndex = 18;
			this.ckbShowBlue.Text = "Blaue Punkte anzeigen";
			this.ckbShowBlue.CheckedChanged += new System.EventHandler(this.ctrl_newValue);
			// 
			// chkShowCalculated
			// 
			this.chkShowCalculated.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.chkShowCalculated.Checked = true;
			this.chkShowCalculated.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkShowCalculated.Location = new System.Drawing.Point(352, 616);
			this.chkShowCalculated.Name = "chkShowCalculated";
			this.chkShowCalculated.Size = new System.Drawing.Size(176, 24);
			this.chkShowCalculated.TabIndex = 19;
			this.chkShowCalculated.Text = "Berechnete Punkte anzeigen";
			this.chkShowCalculated.CheckedChanged += new System.EventHandler(this.ctrl_newValue);
			// 
			// chkShowMeasured
			// 
			this.chkShowMeasured.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.chkShowMeasured.Checked = true;
			this.chkShowMeasured.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkShowMeasured.Location = new System.Drawing.Point(352, 648);
			this.chkShowMeasured.Name = "chkShowMeasured";
			this.chkShowMeasured.Size = new System.Drawing.Size(176, 24);
			this.chkShowMeasured.TabIndex = 20;
			this.chkShowMeasured.Text = "Gemessene Punkte anzeigen";
			this.chkShowMeasured.CheckedChanged += new System.EventHandler(this.ctrl_newValue);
			// 
			// chkShowTrajectoryID
			// 
			this.chkShowTrajectoryID.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.chkShowTrajectoryID.Checked = true;
			this.chkShowTrajectoryID.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkShowTrajectoryID.Location = new System.Drawing.Point(24, 744);
			this.chkShowTrajectoryID.Name = "chkShowTrajectoryID";
			this.chkShowTrajectoryID.Size = new System.Drawing.Size(176, 24);
			this.chkShowTrajectoryID.TabIndex = 20;
			this.chkShowTrajectoryID.Text = "TrajektorienID anzeigen";
			this.chkShowTrajectoryID.CheckedChanged += new System.EventHandler(this.ctrl_newValue);
			// 
			// frmDebug
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(1113, 851);
			this.Controls.Add(this.chkShowMeasured);
			this.Controls.Add(this.chkShowCalculated);
			this.Controls.Add(this.ckbShowBlue);
			this.Controls.Add(this.ckbShowGreen);
			this.Controls.Add(this.ckbShowRed);
			this.Controls.Add(this.pcbYT);
			this.Controls.Add(this.pcbXT);
			this.Controls.Add(this.lblSizeOfFP);
			this.Controls.Add(this.nudFPSize);
			this.Controls.Add(this.ckbShowTrajectories);
			this.Controls.Add(this.ckbShowFP);
			this.Controls.Add(this.ckbMarkCurrentFrame);
			this.Controls.Add(this.lblNrOfFrames);
			this.Controls.Add(this.lblCurrentFrame);
			this.Controls.Add(this.lblNrOfFrameslbl);
			this.Controls.Add(this.lblCurrentFramelbl);
			this.Controls.Add(this.hsbFrame);
			this.Controls.Add(this.trbNrOfFrames);
			this.Controls.Add(this.pcbXY);
			this.Controls.Add(this.chkShowTrajectoryID);
			this.Menu = this.mnuMain;
			this.Name = "frmDebug";
			this.Text = "frmDebug";
			this.Load += new System.EventHandler(this.frmDebug_Load);
			((System.ComponentModel.ISupportInitialize)(this.trbNrOfFrames)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.nudFPSize)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void pcbView_Click(object sender, System.EventArgs e)
		{
		
		}


		private void pcbViews_Paint(object sender, PaintEventArgs e)
		{
			int minframe = System.Math.Max(_currentFrame-(_nrOfFrames-1)/2,0);
			int maxframe = System.Math.Min(minframe +(_nrOfFrames-1),_data[0].CountFrames());
			int i;
			int j;
			int k;
			float scaleX = (float)(e.ClipRectangle.Width)/_nrOfFrames;
			float scaleY = (float)(e.ClipRectangle.Height)/_nrOfFrames;;
			float scaleXY_X = (float)(e.ClipRectangle.Width/640.0);
			float scaleXY_Y = (float)(e.ClipRectangle.Height/480.0);
			FeaturePoint P;


			System.Drawing.Pen mypen_red = new Pen(Color.Red);
			System.Drawing.Pen mypen_blue = new Pen(Color.Blue);
			System.Drawing.Pen mypen_green = new Pen(Color.Green);
			System.Drawing.Pen mypen_white = new Pen(Color.Gray);
			System.Drawing.Pen mypen_standard = new Pen(Color.Black);

			System.Drawing.Pen mypen= mypen_standard;

			Brush mybrush = Brushes.AliceBlue;

			for(i=minframe;i<=maxframe;i++)
			{
				for (k=0; k<_data.Length;k++)
				{
					//Show only activated colors, index of k for R=0, G=1, B=2
					if ((k==0 && _blnShowRed) || (k==1 && _blnShowGreen) || (k==2 && _blnShowBlue))
					{
						for (j=0; j<_data[k].Count(i);j++)
						{
							P = _data[k].P(i,j);
							switch (P.Color)
							{
								case eColorCode.R:
									mypen = mypen_red;
									mybrush = System.Drawing.Brushes.Red;
									break;
								case eColorCode.B:
									mypen = mypen_blue;
									mybrush = System.Drawing.Brushes.Blue;
									break;
							
								case eColorCode.G:
									mypen = mypen_green;
									mybrush = System.Drawing.Brushes.Green;
									break;
	
								case eColorCode.W:
									mypen = mypen_standard;
									mybrush = System.Drawing.Brushes.Gray;
									break;
							}


							//Draw Trajectories if option is activated
							if (_blnShowTrajectories)
							{
								if ((P.Type == eFPType.measured && _blnShowMeasured) || (P.Type == eFPType.calculated && _blnShowCalculated))
								if (P.next !=null)
								{
									if (sender.Equals(pcbXY))
										e.Graphics.DrawLine(mypen_standard,scaleXY_X*P.X,scaleXY_Y*P.Y,scaleXY_X*P.next.X,scaleXY_Y*P.next.Y);
									if (sender.Equals(pcbXT))
										e.Graphics.DrawLine(mypen_standard,scaleXY_X* P.X,scaleY*(i-minframe),scaleXY_X*P.next.X,scaleY*((i-minframe)+1));
									if (sender.Equals(pcbYT))
										e.Graphics.DrawLine(mypen_standard,scaleX*(i-minframe),scaleXY_Y*P.Y,scaleX*((i-minframe)+1),scaleXY_Y*P.next.Y);
								}
							}
							
							if (_blnShowTrajectoryID)
							if ((P.Type == eFPType.measured && _blnShowMeasured) || (P.Type == eFPType.calculated && _blnShowCalculated))
							{
								//Draw TrajectoryID
								if (i==_currentFrame)
									if (sender.Equals(pcbXY))
										e.Graphics.DrawString(P.tid.ToString(), new Font("Arial",8.0f), Brushes.Black, scaleXY_X*P.X - _intFPSize/2 - 8,scaleXY_Y*P.Y - _intFPSize/2 -12);
								if (sender.Equals(pcbXT))
									e.Graphics.DrawString(P.tid.ToString(), new Font("Arial",8.0f), Brushes.Black, scaleXY_X*P.X - _intFPSize/2 - 8,scaleY*(i-minframe) - _intFPSize/2 -12);
								if (sender.Equals(pcbYT))
									e.Graphics.DrawString(P.tid.ToString(), new Font("Arial",8.0f), Brushes.Black, scaleX*(i-minframe)  - _intFPSize/2 - 8,scaleXY_Y*P.Y - _intFPSize/2 -12);
							}
							//Draw Featurepoint if option is activated
							if (_blnShowFP) 
							{
								if (P.Type == eFPType.measured && _blnShowMeasured)
								{
									if (sender.Equals(pcbXY))
										e.Graphics.FillRectangle(mybrush,scaleXY_X*P.X - _intFPSize/2, scaleXY_Y*P.Y - _intFPSize/2,_intFPSize,_intFPSize); 
									if (sender.Equals(pcbXT))
										e.Graphics.FillRectangle(mybrush,scaleXY_X*P.X - _intFPSize/2, scaleY*(i-minframe) - _intFPSize/2,_intFPSize,_intFPSize); 
									if (sender.Equals(pcbYT))
										e.Graphics.FillRectangle(mybrush,scaleX*(i-minframe)  - _intFPSize/2, scaleXY_Y*P.Y - _intFPSize/2,_intFPSize,_intFPSize); 
								}
								else if(P.Type == eFPType.calculated && _blnShowCalculated)
								{
									if (sender.Equals(pcbXY))
										e.Graphics.DrawRectangle(mypen,scaleXY_X*P.X - _intFPSize/2, scaleXY_Y*P.Y - _intFPSize/2,_intFPSize,_intFPSize); 
									if (sender.Equals(pcbXT))
										e.Graphics.DrawRectangle(mypen,scaleXY_X*P.X - _intFPSize/2, scaleY*(i-minframe) - _intFPSize/2,_intFPSize,_intFPSize); 
									if (sender.Equals(pcbYT))
										e.Graphics.DrawRectangle(mypen,scaleX*(i-minframe)  - _intFPSize/2, scaleXY_Y*P.Y - _intFPSize/2,_intFPSize,_intFPSize); 
								}
							}
	
							//Mark Featurepoints of current Frame if option is activated
							if (_blnMarkCurrentFrame) 
							{
								if (i==_currentFrame)
								{

									if (sender.Equals(pcbXY))
										e.Graphics.DrawRectangle(mypen_standard,scaleXY_X*P.X - (_intFPSize+2)/2, scaleXY_Y*P.Y - (_intFPSize+2)/2,_intFPSize+2,_intFPSize+2);
									if (sender.Equals(pcbXT))
										e.Graphics.DrawRectangle(mypen_standard,  scaleXY_X*P.X - (_intFPSize+2)/2, scaleY*(i-minframe) - (_intFPSize+2)/2,_intFPSize+2,_intFPSize+2);
									if (sender.Equals(pcbYT))
										e.Graphics.DrawRectangle(mypen_standard,scaleX*(i-minframe) - (_intFPSize+2)/2, scaleXY_Y*P.Y - (_intFPSize+2)/2,_intFPSize+2,_intFPSize+2);
								}					
							}
						}
					}
				}
			}
			//Console.WriteLine("PAINTED");

		}

		private void frmDebug_Load(object sender, System.EventArgs e)
		{
		
		}

		private void trbNrOfFrames_Scroll(object sender, System.EventArgs e)
		{
			GatherData();
			SeedData();

			pcbXY.Refresh();
			pcbXT.Refresh();
			pcbYT.Refresh();
		}

		private void hsbFrame_Scroll(object sender, System.Windows.Forms.ScrollEventArgs e)
		{
			GatherData();
			SeedData(); 
			
		}

		
		private void SeedData()
		{
			//Lock GatherData
			hsbFrame.Maximum = _data[0].CountFrames();
			_blnUpdating = true;

			lblNrOfFrames.Text = _nrOfFrames.ToString();
			lblCurrentFrame.Text = _currentFrame.ToString();

			nudFPSize.Value = _intFPSize;
			ckbShowFP.Checked = _blnShowFP;
			ckbMarkCurrentFrame.Checked = _blnMarkCurrentFrame;
			ckbShowTrajectories.Checked = _blnShowTrajectories;

			ckbShowRed.Checked = _blnShowRed;
			ckbShowGreen.Checked = _blnShowGreen;
			ckbShowBlue.Checked = _blnShowBlue;

			chkShowCalculated.Checked = _blnShowCalculated;
			chkShowMeasured.Checked = _blnShowMeasured;

			chkShowTrajectoryID.Checked = _blnShowTrajectoryID;
			


			pcbXY.Refresh();
			pcbXT.Refresh();
			pcbYT.Refresh();

			_blnUpdating = false; 
		}

		private void GatherData()
		{
			if (!_blnUpdating)
			{
				_currentFrame = hsbFrame.Value;
				_nrOfFrames = trbNrOfFrames.Value;

				_intFPSize = int.Parse(nudFPSize.Value.ToString()) ;
				_blnShowFP = ckbShowFP.Checked;
				_blnMarkCurrentFrame = ckbMarkCurrentFrame.Checked ;
				_blnShowTrajectories = ckbShowTrajectories.Checked ;

				_blnShowRed = ckbShowRed.Checked;
				_blnShowGreen = ckbShowGreen.Checked;
				_blnShowBlue = ckbShowBlue.Checked;

				_blnShowCalculated= chkShowCalculated.Checked;
				_blnShowMeasured = chkShowMeasured.Checked;

				_blnShowTrajectoryID = chkShowTrajectoryID.Checked;


			}
		}

		/// <summary>
		/// This is a unifying procedure which handles all Value changing in any of its connected controls
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void ctrl_newValue(object sender, System.EventArgs e)
		{
			GatherData();
			SeedData();
		}

		private void mnuListOpen_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog oFD = new OpenFileDialog();
			oFD.Title = "Select *.dat File";
			oFD.Filter = "*.dat files (*.dat)|*.dat|All File Types (*.*)|*.*";

			oFD.ShowDialog();

			if(oFD.ShowDialog(this) == DialogResult.OK)
			{
				if (oFD.CheckPathExists)
				{
				
				}
			}
		}

		private void lblCurrentFramelbl_Click(object sender, System.EventArgs e)
		{
		
		}


	



		public int CurrentFrame
		{
			get {return _currentFrame;}
			set {_currentFrame = value; SeedData();}
		}
		





	}
}
