using System;
using System.Collections;
using System.Runtime.Serialization;

namespace MT.Tracker.DataStructures
{
	/// <summary>
	/// FeaturePointFrameColor stores Featurepoints which belong to one single Frame
	/// from one single Camera.
	/// </summary>
	public class FeaturePointFrameColor:SortedList
	{
		protected eColorCode	_Color;		//Stores Color of Featurepoint Members
		protected int			_fid;		//Stores FrameID
		protected string		_cid;		//Stores CameraID

		protected int			_Sync;		//Contains an Integer Flag which was received from the server.
											//this is required for synchronizaton of all the different Camera
											//Flags.

		/// <summary>
		/// Gets FrameColor
		/// </summary>
		public eColorCode Color
		{	get { return _Color; }	 }

		/// <summary>
		/// Gets the Framenumber
		/// </summary>
		public int fid
		{	get { return _fid; }
			set { _fid = value; }
		}

		public string cid
		{	get { return _cid; }
			set { _cid = value; }
		}

		public virtual int Sync
		{	get { return _Sync; }
			set { _Sync = value; }
		}

		public FeaturePointFrameColor(eColorCode Color, int fid, string cid)
		{
			_Color = Color;
			_fid = fid;
			_cid = cid;
		}
		protected FeaturePointFrameColor()
		{}

		public virtual void Add(FeaturePoint FP)
		{
			base.Add(FP.fid, FP);
		}

		public	FeaturePoint P			(int Index)
		{	
			return (FeaturePoint)base.GetByIndex(Index);
		}

	
	}
}
