using System;

namespace MT.Tracker.DataStructures
{
	/// <summary>
	/// Interface to define access methods
	/// for FeaturePointData Classes
	/// </summary>
	interface IFeaturePointData
	{
		/// <summary>
		/// Checks if the given Framenumber exists.
		/// </summary>
		/// <param name="Frame">FrameNumber</param>
		/// <returns></returns>
		bool		existsFrame	(int Frame);
	
		/// <summary>
		/// Counts Number of Points in the given Frame
		/// </summary>
		/// <param name="Frame">FrameNumber</param>
		/// <returns></returns>
		int			Count		(int Frame);


		/// <summary>
		/// Returns FeaturePoint Set of given Frame
		/// </summary>
		/// <param name="fnr">FrameNumber</param>
		/// <returns></returns>
		FeaturePointFrame GetFrame	(int fnr);

		/// <summary>
		/// Returns Featurepoint according to its Frame
		/// and Index Number
		/// </summary>
		/// <param name="Frame">FrameNumber</param>
		/// <param name="Index">IndexNumber</param>
		/// <returns></returns>
		FeaturePoint P			(int Frame, int Index);

	}
}
