using System;
using System.Collections;

namespace MT.Tracker.DataStructures
{
	/// <summary>
	/// Zusammenfassung fr clsFPFrameArray.
	/// </summary>
	public class clsFPFrameArray: clsFPFrameArrayColor
	{
		private clsFPFrameArrayColor	_red;
		private clsFPFrameArrayColor	_green;
		private clsFPFrameArrayColor	_blue;

		public clsFPFrameArrayColor F_Red
		{
			get { return _red; }
		}

		public clsFPFrameArrayColor F_Green
		{
			get { return _green; }
		}

		public clsFPFrameArrayColor F_Blue
		{
			get { return _blue; }
		}

		public clsFPFrameArray(int FrameNumber): base(eColorCode.none,FrameNumber)
		{
			_red =		new clsFPFrameArrayColor(eColorCode.R,FrameNumber);
			_green =	new clsFPFrameArrayColor(eColorCode.G,FrameNumber);
			_blue =		new clsFPFrameArrayColor(eColorCode.B,FrameNumber);
		}
		public clsFPFrameArray(string input)
		{	

			//Temporary Array to split out Headerdata from message
			string[] header = new string[3];

			
			header = input.Split(new char[1] {'\t'},3);

			//Extract Framenumber
			base._fid = int.Parse(header[0]);


			_red = new clsFPFrameArrayColor(eColorCode.R,base._fid);
			_green = new clsFPFrameArrayColor(eColorCode.G,base._fid);
			_blue = new clsFPFrameArrayColor(eColorCode.B,base._fid);

			int FrameCount = int.Parse(header[1]);
			
			if (FrameCount>0)
			{
				//Temporary Arrary to split out FeaturepointFrames from Message
				string[] Frames = new string[FrameCount];

				Frames = header[2].Split(new char[1] {'\t'},FrameCount);

				FeaturePointFrame Frame;

				for (int i =0; i< FrameCount;i++)
				{
					Frame = new FeaturePointFrame(Frames[i]);
					Add(Frame.cid, Frame);
				}
			}
		}


		public override void Add(string cid, FeaturePointFrame frame)
		{
			//Add Frame to the base collection
			base.Add(cid,frame);

			_red.Add(cid, frame.Pred);
			_green.Add(cid, frame.Pgreen);
			_blue.Add(cid, frame.Pblue);

		}

		public override string ToString()
		{	
			//Store Class Information
			string r = "";
			string cid;
			FeaturePointFrame frame;

			r += base._fid + "\t";
			r += base.Count.ToString();
				
			//Store Collection Members
			foreach(DictionaryEntry DE in this)
			{
				cid = (string)DE.Key;
				frame = (FeaturePointFrame)DE.Value;

				r += "\t" + frame.ToString();
			}

			return r;

		}

	}
}
