using System;
using System.Runtime.Serialization;

namespace MT.Tracker.DataStructures
{
	/// <summary>
	/// Defines Basic 2-dimensional Vector Arithemtic Methods
	/// </summary>
	[Serializable]
	public class vector2f//: ISerializable
	{
		protected float _X = -1;
		protected float _Y = -1;

		public vector2f(){}
		public vector2f(float X, float Y)
		{
			_X = X;
			_Y = Y;
		}


		public	float		X
		{
			get { return _X;  }
			set { _X = value; }
		}

		public	float		Y
		{
			get { return _Y;  }
			set { _Y = value; }
		}


		public	float		dot(vector2f v)
		{
			return (float)_X*v._X + _Y*v._Y; 
		}

		public	float		length
		{
			get { return  (float)Math.Sqrt(_X*_X + _Y*_Y); }
		}


		public	static float	operator *(vector2f v1, vector2f v2)
		{
			return v1.dot(v2);
		}
	
		public	static vector2f operator -(vector2f v1, vector2f v2)
		{
			return new vector2f(v1._X - v2._X, v1._Y - v2._Y);
		}

		public	static vector2f operator +(vector2f v1, vector2f v2)
		{
			return new vector2f(v1._X + v2._X, v1._Y + v2._Y);
		}

		#region ISerializable Members

//		public void GetObjectData(SerializationInfo info, StreamingContext context)
//		{
//			info.AddValue("_X", _X);
//			info.AddValue("_Y", _Y);
//		}
//
//		private vector2f(SerializationInfo info, StreamingContext context)
//		{
//			_X = info.GetSingle("_X");
//			_Y = info.GetSingle("_Y");
//		}

		#endregion
	}
}
