using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using GraphController;
using DShowNET;
using DShowNET.Device;
using MT.Network;

namespace MTClient
{


/// <summary> Dialog to let user select a capture device if more then one installed. </summary>
public class DeviceSelector : System.Windows.Forms.Form
{
	private clsClientController			_MTClient;
	private FilterGraphController		_filterGraphController =null;
	private Filters						_filters = null;
	private const string clipFileFilters =
		"Video Files (avi qt mov mpg mpeg m1v)|*.avi;*.qt;*.mov;*.mpg;*.mpeg;*.m1v|" +
		"All Files (*.*)|*.*";

	private System.Windows.Forms.Button okButton;
	private System.Windows.Forms.ColumnHeader nameColHd;
	private System.Windows.Forms.Button cancelButton;
	private System.Windows.Forms.Label label1;
	private System.Windows.Forms.RadioButton rbnFilterServer;
	private System.Windows.Forms.RadioButton rbnFPDetector;
	private System.Windows.Forms.ListView lvwDevices;
	private System.Windows.Forms.ListBox lsbServers;
	private System.Windows.Forms.Label lblSelectServer;
	/// <summary> Required designer variable. </summary>
	private System.ComponentModel.Container components = null;

	public DeviceSelector()
	{
		// Required for Windows Form Designer support
		InitializeComponent();

	}

	/// <summary> Clean up any resources being used. </summary>
	protected override void Dispose( bool disposing )
	{
		if( disposing )
		{
			if(components != null)
			{
				components.Dispose();
			}
		}
		base.Dispose( disposing );
	}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.okButton = new System.Windows.Forms.Button();
			this.lvwDevices = new System.Windows.Forms.ListView();
			this.nameColHd = new System.Windows.Forms.ColumnHeader();
			this.cancelButton = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.rbnFilterServer = new System.Windows.Forms.RadioButton();
			this.rbnFPDetector = new System.Windows.Forms.RadioButton();
			this.lsbServers = new System.Windows.Forms.ListBox();
			this.lblSelectServer = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// okButton
			// 
			this.okButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.okButton.Location = new System.Drawing.Point(96, 264);
			this.okButton.Name = "okButton";
			this.okButton.Size = new System.Drawing.Size(96, 24);
			this.okButton.TabIndex = 4;
			this.okButton.Text = "&OK";
			this.okButton.Click += new System.EventHandler(this.okButton_Click);
			// 
			// lvwDevices
			// 
			this.lvwDevices.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						 this.nameColHd});
			this.lvwDevices.FullRowSelect = true;
			this.lvwDevices.GridLines = true;
			this.lvwDevices.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvwDevices.HideSelection = false;
			this.lvwDevices.Location = new System.Drawing.Point(32, 144);
			this.lvwDevices.MultiSelect = false;
			this.lvwDevices.Name = "lvwDevices";
			this.lvwDevices.Size = new System.Drawing.Size(344, 112);
			this.lvwDevices.TabIndex = 2;
			this.lvwDevices.View = System.Windows.Forms.View.Details;
			// 
			// nameColHd
			// 
			this.nameColHd.Text = "Name";
			this.nameColHd.Width = 400;
			// 
			// cancelButton
			// 
			this.cancelButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.cancelButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cancelButton.Location = new System.Drawing.Point(192, 264);
			this.cancelButton.Name = "cancelButton";
			this.cancelButton.Size = new System.Drawing.Size(88, 24);
			this.cancelButton.TabIndex = 3;
			this.cancelButton.Text = "&Cancel";
			this.cancelButton.Click += new System.EventHandler(this.cancelButton_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(40, 23);
			this.label1.TabIndex = 5;
			// 
			// rbnFilterServer
			// 
			this.rbnFilterServer.Checked = true;
			this.rbnFilterServer.Location = new System.Drawing.Point(80, 8);
			this.rbnFilterServer.Name = "rbnFilterServer";
			this.rbnFilterServer.TabIndex = 6;
			this.rbnFilterServer.TabStop = true;
			this.rbnFilterServer.Text = "FilterServer";
			// 
			// rbnFPDetector
			// 
			this.rbnFPDetector.Location = new System.Drawing.Point(184, 8);
			this.rbnFPDetector.Name = "rbnFPDetector";
			this.rbnFPDetector.TabIndex = 7;
			this.rbnFPDetector.Text = "FPDetector";
			// 
			// lsbServers
			// 
			this.lsbServers.Items.AddRange(new object[] {
															"Solo Mode"});
			this.lsbServers.Location = new System.Drawing.Point(32, 56);
			this.lsbServers.Name = "lsbServers";
			this.lsbServers.Size = new System.Drawing.Size(344, 69);
			this.lsbServers.TabIndex = 8;
			// 
			// lblSelectServer
			// 
			this.lblSelectServer.Location = new System.Drawing.Point(32, 40);
			this.lblSelectServer.Name = "lblSelectServer";
			this.lblSelectServer.Size = new System.Drawing.Size(344, 16);
			this.lblSelectServer.TabIndex = 9;
			this.lblSelectServer.Text = "Server whlen:";
			// 
			// DeviceSelector
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(394, 295);
			this.Controls.Add(this.cancelButton);
			this.Controls.Add(this.lblSelectServer);
			this.Controls.Add(this.lsbServers);
			this.Controls.Add(this.rbnFPDetector);
			this.Controls.Add(this.rbnFilterServer);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.okButton);
			this.Controls.Add(this.lvwDevices);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "DeviceSelector";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Konfiguration";
			this.TopMost = true;
			this.ResumeLayout(false);

		}
		#endregion


	public void Initalize(clsClientController MTClient)
	{
		_MTClient = MTClient;
		_filters = MTClient.Filters;
		
		_MTClient.NetClient.ServerList +=new MTClient.clsNetworkClient.ServerListDelegate(NetClient_ServerList);

		rbnFPDetector.Tag = enuSWFilterMode.CSharpSWFilter;
		rbnFilterServer.Tag = enuSWFilterMode.DirectShowSWFilter;



		Filter f;
		ListViewItem item = null;

		// Load video devices
		Filter videoDevice = null;

//		if (  _filterGraphController != null )
//			videoDevice = _filterGraphController.VideoDevice;
			
		lvwDevices.Items.Clear();


		item = new ListViewItem( "Select Source Video..." );
		item.Checked = ( videoDevice == null );
		lvwDevices.Items.Add( item );

		if( _filters.VideoInputDevices.Count == 0 )
		{
			MessageBox.Show( this, "No video capture devices found!", "DirectShow.NET", MessageBoxButtons.OK, MessageBoxIcon.Stop );
			this.Close();
			return;
		}

		for ( int c = 0; c < _filters.VideoInputDevices.Count; c++ )
		{
			f = _filters.VideoInputDevices[c];
			item = new ListViewItem(c+1 + " " + f.Name );
			item.Checked = ( videoDevice == f );
			lvwDevices.Items.Add( item );
		}
		lvwDevices.Enabled = ( _filters.VideoInputDevices.Count > 0 );
	}

	private void lvwDevices_DoubleClick(object sender, System.EventArgs e)
	{
		this.okButton_Click( sender, e );
	}

	private void okButton_Click(object sender, System.EventArgs e)
	{
//		strSettings Settings = new strSettings();

		if (lsbServers.Items.Count == 0)
		{
			DialogResult r = MessageBox.Show("Es wurde bisher kein Server gefunden. \nSoll der Client im Solomodus gestartet werden?\nIn diesem Falle wrde der Client nie zu einem Server verbinden, auch wenn einer vorhanden wre.","Kein Server vorhanden.", MessageBoxButtons.YesNo,MessageBoxIcon.Exclamation,MessageBoxDefaultButton.Button1);
			switch(r)
			{
				case DialogResult.Yes:
					break;

				case DialogResult.No:
					return;
			}
		}
		else if (lsbServers.SelectedIndex < 0)
		{
			MessageBox.Show("Bitte zuerst einen Server auswhlen!");
			return;
		}
		else 
		{
			try
			{
				_MTClient.NetClient.Connect((strConInfo)lsbServers.SelectedItem);
			}
			catch
			{
				Console.WriteLine("Running in SoloMode");
			}
			}

		//frmClient ClientWindow = new frmClient();
		
		//MessageBox.Show("ThreadHashcode: " + System.Threading.Thread.CurrentThread.GetHashCode().ToString());

		// Get current devices and dispose of capture object
		// because the video and audio device can only be changed
		// by creating a new Capture object.
		Filter videoDevice = null;
		Filter audioDevice = null;
		string sourceFile = null;

		if ( _filterGraphController != null )
		{
			videoDevice = _filterGraphController.VideoDevice;

			_filterGraphController.Dispose();
			_filterGraphController = null;
		}

		// Get new video device
		if( lvwDevices.SelectedItems.Count != 1 )
			return;
		ListViewItem selitem = lvwDevices.SelectedItems[0];
		if(selitem.Index == 0)
		{
			OpenFileDialog af = new OpenFileDialog();
			af.Title = "Open Media File...";
			af.Filter = clipFileFilters;
			if( af.ShowDialog() != DialogResult.OK )
				return;

			sourceFile = af.FileName;	
			
		}
		else
		{
			videoDevice = ( selitem.Index>=0 ? _filters.VideoInputDevices[selitem.Index-1] : null );
		}

		// If a capture device has been selected, initalize the MTClientController class
		if ( ( videoDevice != null ) )
		{

	
			if (rbnFPDetector.Checked)
				_MTClient.SetupDevice(videoDevice,(enuSWFilterMode)rbnFPDetector.Tag );

			else if (rbnFilterServer.Checked)
				_MTClient.SetupDevice(videoDevice,(enuSWFilterMode)rbnFilterServer.Tag );

			//Moved those calls into _MTClient.InitializeFilterGraphController
			//			_filterGraphController = new FilterGraphController( videoDevice );
			//			_filterGraphController.CaptureComplete += new EventHandler( OnCaptureComplete );
		}
		else
		{
			if (rbnFPDetector.Checked)
				_MTClient.SetupSource(sourceFile, audioDevice, (enuSWFilterMode)rbnFPDetector.Tag );

			else if (rbnFilterServer.Checked)
				 _MTClient.SetupSource(sourceFile, audioDevice, (enuSWFilterMode)rbnFilterServer.Tag );
		}

		

//		ClientWindow.ShowDialog();

		Close();
	}

	private void cancelButton_Click(object sender, System.EventArgs e)
	{
		Close();
	}

	private void OnCaptureComplete(object sender, EventArgs e)
	{
		// Demonstrate the Capture.CaptureComplete event.
		Console.WriteLine( "Capture complete." );
	}

	private void NetClient_ServerList(MT.Network.strConInfo[] ConInfos)
	{
		lsbServers.Items.Clear();
		lsbServers.Items.Add("Solo Mode");
		for(int i = 0 ; i<ConInfos.Length;i++)
		{
			
			lsbServers.Items.Add(ConInfos[i]);
		}

		//Select first Element if available
		if (lsbServers.Items.Count > 0)
		{
			lsbServers.SelectedIndex=0;
		}
	}
}

}
