using System;
using System.Runtime.InteropServices;
using System.Drawing;
using System.Drawing.Imaging;
using GraphController;
using DShowNET;

namespace MTClient
{
	/// <summary>
	/// Zusammenfassung fr clsCapture.
	/// </summary>
	public class clsCapture
	{
		private FilterGraphController _FilterGraphController;
//		private Filters								_filters;
//		private System.Windows.Forms.Panel			_myCapturePanel;
//		private System.Windows.Forms.Form		    _myCapture;
		private IAMStreamConfig						videoStreamConfig=null;

		public clsCapture(FilterGraphController FilterGraphController)
		{
//			_filters = filters;
			_FilterGraphController = FilterGraphController;
//			_myCapturePanel = myCapturePanel;
//			_myCapture = myCapture;



			//videoStreamConfig = _FilterGraphController.IAMStreamConfigInit();


		}

		public void Property(int PrevCapTrans)
		{
			//PrevCapTrans = 1 Show Webcam Property
			//PrevCapTrans = 2 Show Capture Property
			//PrevCapTrans = 3 Show Transform Property
			if(PrevCapTrans == 1)
			{
				//_FilterGraphController.PropertyPrev();
			}
			else if(PrevCapTrans == 2)
			{
//				_FilterGraphController.Stop();
//				_FilterGraphController.PropertyCap();
//				_FilterGraphController.Start();
			}
			else if(PrevCapTrans == 3)
			{
//				_FilterGraphController.PropertyTrans();
			}
		}


		public bool setResolution(Size Resolution)
		{
			AMMediaType mediaType = null;
			VideoStreamConfigCaps caps = null;
			IntPtr pCaps = IntPtr.Zero;
			try
			{

				// Ensure this device reports capabilities
				int c, size;
				int hr = videoStreamConfig.GetNumberOfCapabilities( out c, out size );
				if ( hr != 0 ) Marshal.ThrowExceptionForHR( hr );
				if ( c <= 0 ) 
					throw new NotSupportedException( "This video device does not report capabilities." );
				if ( size > Marshal.SizeOf( typeof( VideoStreamConfigCaps ) ) )
					throw new NotSupportedException( "Unable to retrieve video device capabilities. This video device requires a larger VideoStreamConfigCaps structure." );
				if ( c > 1 )
					Console.WriteLine("This video device supports " + c + " capability structures. Only the first structure will be used." );

				// Alloc memory for structure
				pCaps = Marshal.AllocCoTaskMem( Marshal.SizeOf( typeof( VideoStreamConfigCaps ) ) ); 

				// Retrieve first (and hopefully only) capabilities struct

				Size[] mySize = new Size[c];
				for (int i = 0; i < c; i++)
				{
					hr = videoStreamConfig.GetStreamCaps( i, out mediaType, pCaps );
					if ( hr != 0 ) Marshal.ThrowExceptionForHR( hr );

					
					// Convert pointers to managed structures
					//mediaType = (AMMediaType) Marshal.PtrToStructure( pMediaType, typeof( AMMediaType ) );
					caps = (VideoStreamConfigCaps) Marshal.PtrToStructure( pCaps, typeof( VideoStreamConfigCaps ) );

					
					Console.WriteLine(mediaType.formatType.ToString());
					Console.WriteLine(mediaType.subType.ToString());
					if (mediaType.formatType == FormatType.VideoInfo &&
						mediaType.subType == MediaSubType.RGB24)
					{
						if (caps.MinOutputSize.Width == Resolution.Width
							&& caps.MinOutputSize.Height == Resolution.Height )
						{
							videoStreamConfig.GetFormat(out mediaType);
							VideoInfoHeader videoInfoHeader = (VideoInfoHeader) Marshal.PtrToStructure( mediaType.formatPtr, typeof(VideoInfoHeader) );
							videoInfoHeader.BmiHeader.Width = caps.MinOutputSize.Width;
							videoInfoHeader.BmiHeader.Height = caps.MinOutputSize.Height;
							Marshal.StructureToPtr(videoInfoHeader, mediaType.formatPtr, true);
							_FilterGraphController.Stop();
							videoStreamConfig.SetFormat(mediaType); 
							_FilterGraphController.Start();
							
						}
					}

					
				}
				return true;
			}
			finally
			{
				if ( pCaps != IntPtr.Zero )
					Marshal.FreeCoTaskMem( pCaps ); pCaps = IntPtr.Zero;
				if ( mediaType != null )
					DsUtils.FreeAMMediaType( mediaType ); mediaType = null;
			}

		}
		public void getResolution()
		{
			AMMediaType media = new AMMediaType();
			videoStreamConfig.GetFormat(out media);
			VideoInfoHeader videoInfoHeader = (VideoInfoHeader) Marshal.PtrToStructure( media.formatPtr, typeof(VideoInfoHeader) );
			Console.WriteLine(videoInfoHeader.BmiHeader.Width.ToString()); 
			Console.WriteLine(videoInfoHeader.BmiHeader.Height.ToString());
			DsUtils.FreeAMMediaType(media);

		}
		

		public string chooseDirectory
		{	
			get
			{
				return _FilterGraphController.SaveCaptureFile();
			}
		}



	


	}
}
