using System;
using System.Windows.Forms;
using System.Collections;
using GraphController;
using DShowNET.Device;
using DShowNET;
namespace MTClient
{
	/// <summary>
	/// Zusammenfassung fr clsMain.
	/// </summary>
	public class clsMain
	{
		

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			/// <summary> list of installed video devices. </summary>
//						ArrayList				capDevices;


			if( ! DsUtils.IsCorrectDirectXVersion() )
			{
				MessageBox.Show("DirectX 8.1 or higher NOT installed!", "DirectShow.NET", MessageBoxButtons.OK, MessageBoxIcon.Stop );
				return;
			}

//			if( ! DsDev.GetDevicesOfCat( FilterCategory.VideoInputDevice, out capDevices ) )
//			{
//				MessageBox.Show("No video capture devices found!", "DirectShow.NET", MessageBoxButtons.OK, MessageBoxIcon.Stop );
//				return;
//			}

			//Main ClientController Class that stores all important Modules
			clsClientController MTClient = new clsClientController();

			System.Threading.Thread.CurrentThread.Name = "Main";


			DeviceSelector frmDevice = new DeviceSelector();
	
			frmDevice.Initalize(MTClient);
			frmDevice.ShowDialog();

			//if MTClient has been initialized in Device Selector Window, create the Main Window
			//otherwise exit the application
			if (MTClient.State == enuControllerState.MainWindow)
			{
				frmClient MainWindow;

				switch (MTClient.CaptureDevice)
				{
					case enuCaptureDevice.Webcam:
						MainWindow = new frmWebcamClient();
						break;
					case enuCaptureDevice.DVCam:
						MainWindow = new frmDVClient();
						break;
					case enuCaptureDevice.Video:
						MainWindow = new frmVideoClient();
						break;
					default:
						MainWindow = new frmWebcamClient();
						break;
				}

				//ClientWindow.InitializeLocal(_filterGraphController,_filters);
				//ClientWindow.InitializeNet(_filterGraphController,_filters);
				MainWindow.Initialize(MTClient);
			
				//frmDevice.Show();
				Application.Run(MainWindow);

			}
			MTClient.Shutdown();
			
		}


	}
}
