using System;
using DShowNET;
using DShowNET.Device;
using GraphController;

namespace MTClient
{
	/// <summary>
	/// Zusammenfassung fr clsVideo.
	/// </summary>
	public class clsVideo
	{
		private FilterGraphController				_FilterGraphController;
		private Filters								_filters;
		private int									_Brightness;
		private int									_Contrast;
		private int									_Gamma;
		private int									_Saturation;
		private int									_Gain;
		private int									_WhiteBalance;
		private int									_BacklightCompensation;
		private int									_ColorEnable;
		private int									_Sharpness;
		private bool								_OnOff;
//		private bool								_Auto;
		private System.Windows.Forms.Panel			_myVideoPanel;
//		private System.Windows.Forms.Form		    _myVideo;
		private IAMVideoControl						_videoControl;
		private IAMVideoProcAmp                     _videoProc;
		private VideoProcAmpFlags					_flag;

		public clsVideo(FilterGraphController filterGraphController, Filters filters, System.Windows.Forms.Panel myVideoPanel)
		{


			_filters = filters;
			_FilterGraphController = filterGraphController;
			_myVideoPanel = myVideoPanel;

			_videoProc = _FilterGraphController.IAMVideoProcAmpInit();
			
			_videoControl = _FilterGraphController.IAMVideoControlInit();

			_flag = new VideoProcAmpFlags();

			_flag = VideoProcAmpFlags.Manual;

		}

		public void Property(int PrevCapTrans)
		{
			_FilterGraphController.VideoControl(_videoControl);
			//PrevCapTrans = 1 Show Webcam Property
			//PrevCapTrans = 2 Show Capture Property
			//PrevCapTrans = 3 Show Transform Property
			if(PrevCapTrans == 1)
			{
//				_FilterGraphController.PropertyPrev();
			}
			else if(PrevCapTrans == 2)
			{
//				_FilterGraphController.Stop();
//				_FilterGraphController.PropertyCap();
//				_FilterGraphController.Start();
			}
			else if(PrevCapTrans == 3)
			{
//				_FilterGraphController.PropertyTrans();
			}
		}


		public void getPropertyRange(videoProp property, out int min, out int max, out int step, out int pdefault)
		{
			max = 0;
			min = 0;
			step= 0;
			pdefault = 0;
			VideoProcAmpFlags flag;
			
			switch (property)
			{
				case videoProp.Brightness:
					_videoProc.GetRange(VideoProcAmpProperty.Brightness, out min, out max, out step, out pdefault, out flag);
					Console.WriteLine("Flag Brightness: " + flag.ToString()+ " Min : " + min.ToString() + " Max :" + max.ToString() + " Step : " + step.ToString() + " Default:" + pdefault);
					break;
				case videoProp.BacklightCompensation:
					_videoProc.GetRange(VideoProcAmpProperty.BacklightCompensation, out min, out max, out step, out pdefault, out flag);
					Console.WriteLine("Flag BacklightCompensation: " + flag.ToString()+ " Min : " + min.ToString() + " Max :" + max.ToString() + " Step : " + step.ToString() + " Default:" + pdefault);
					break;
				case videoProp.ColorEnable:
					_videoProc.GetRange(VideoProcAmpProperty.ColorEnable, out min, out max, out step, out pdefault, out flag);
					Console.WriteLine("Flag ColorEnable: " + flag.ToString()+ " Min : " + min.ToString() + " Max :" + max.ToString() + " Step : " + step.ToString() + " Default:" + pdefault);
					break;
				case videoProp.Contrast:
					_videoProc.GetRange(VideoProcAmpProperty.Contrast, out min, out max, out step, out pdefault, out flag);
					Console.WriteLine("Flag Contrast: " + flag.ToString()+ " Min : " + min.ToString() + " Max :" + max.ToString() + " Step : " + step.ToString() + " Default:" + pdefault);
					break;
				case videoProp.Gain:
					_videoProc.GetRange(VideoProcAmpProperty.Gain, out min, out max, out step, out pdefault, out flag);
					Console.WriteLine("Flag Gain: " + flag.ToString() + " Min : " + min.ToString() + " Max :" + max.ToString() + " Step : " + step.ToString() + " Default:" + pdefault);
					break;
				case videoProp.Gamma:
					_videoProc.GetRange(VideoProcAmpProperty.Gamma, out min, out max, out step, out pdefault, out flag);
					Console.WriteLine("Flag Gamma: " + flag.ToString() + " Min : " + min.ToString() + " Max :" + max.ToString() + " Step : " + step.ToString() + " Default:" + pdefault);
					break;
				case videoProp.Hue:
					_videoProc.GetRange(VideoProcAmpProperty.Hue, out min, out max, out step, out pdefault, out flag);
					Console.WriteLine("Flag Hue: " + flag.ToString() + " Min : " + min.ToString() + " Max :" + max.ToString() + " Step : " + step.ToString() + " Default:" + pdefault);
					break;
				case videoProp.Saturation:
					_videoProc.GetRange(VideoProcAmpProperty.Saturation, out min, out max, out step, out pdefault, out flag);
					Console.WriteLine("Flag Saturation: " + flag.ToString() + " Min : " + min.ToString() + " Max :" + max.ToString() + " Step : " + step.ToString() + " Default:" + pdefault);
					break;
				case videoProp.Sharpness:
					_videoProc.GetRange(VideoProcAmpProperty.Sharpness, out min, out max, out step, out pdefault, out flag);
					Console.WriteLine("Flag Sharpness: " + flag.ToString() + " Min : " + min.ToString() + " Max :" + max.ToString() + " Step : " + step.ToString() + " Default:" + pdefault);
					break;
				case videoProp.WhiteBalance:
					_videoProc.GetRange(VideoProcAmpProperty.WhiteBalance, out min, out max, out step, out pdefault, out flag);
					Console.WriteLine("Flag WhiteBalance: " + flag.ToString() + " Min : " + min.ToString() + " Max :" + max.ToString() + " Step : " + step.ToString() + " Default:" + pdefault);
					break;
			}
		}

		public bool ckbOnOff
		{

			set
			{
				_OnOff = value;
				if(_OnOff)
				{
					try
					{
						if ( _FilterGraphController.PreviewWindow == null )
							_FilterGraphController.PreviewWindow = _myVideoPanel;
					}
					catch (Exception ex)
					{ 
						Console.WriteLine ( "Unable to enable/disable preview. Please submit a bug report.\n\n" + ex.Message + "\n\n" + ex.ToString() );
					}

				}
				else
				{
					try
					{
						_FilterGraphController.PreviewWindow = null;
					}
					catch (Exception ex)
					{ 
						Console.WriteLine ( "Unable to enable/disable preview. Please submit a bug report.\n\n" + ex.Message + "\n\n" + ex.ToString() );
					}
				}

			}

		}

		public int Brightness
		{
			get
			{
				_videoProc.Get(VideoProcAmpProperty.Brightness, out _Brightness, out _flag);
				return _Brightness;
			}

			set
			{
				_Brightness = value;							
				_videoProc.Set(VideoProcAmpProperty.Brightness, _Brightness, _flag);	
			}
		}

		public int Contrast
		{
			get
			{
				
				_videoProc.Get(VideoProcAmpProperty.Contrast , out _Contrast, out _flag);
				return _Contrast;
			}

			set
			{
				_Contrast = value;
				_videoProc.Set(VideoProcAmpProperty.Contrast, _Contrast, _flag);		
			}
		}

		public int Gamma
		{
			get
			{
				_videoProc.Get(VideoProcAmpProperty.Gamma, out _Gamma, out _flag);
				return _Gamma;
			}

			set
			{

				_Gamma = value;
				_videoProc.Set(VideoProcAmpProperty.Gamma, _Gamma, _flag);	
			}
		}

		public int Saturation
		{
			get
			{
				_videoProc.Get(VideoProcAmpProperty.Saturation, out _Saturation, out _flag);	
				return _Saturation;
			}

			set
			{
				_Saturation = value;
				_videoProc.Set(VideoProcAmpProperty.Saturation, _Saturation, _flag);
			}
		}

		public int Sharpness
		{
			get
			{
				_videoProc.Get(VideoProcAmpProperty.Sharpness, out _Brightness, out _flag);
				return _Sharpness;
			}

			set
			{
				_Sharpness = value;							
				_videoProc.Set(VideoProcAmpProperty.Sharpness, _Sharpness, _flag);	
			}
		}

		public int Gain
		{
			get
			{
				_videoProc.Get(VideoProcAmpProperty.Gain, out _Gain, out _flag);	
				return _Gain;
			}

			set
			{
				_Gain = value;
				_videoProc.Set(VideoProcAmpProperty.Gain, _Gain, _flag);
			}
		}

		public int WhiteBalance
		{
			get
			{
				_videoProc.Get(VideoProcAmpProperty.WhiteBalance , out _WhiteBalance, out _flag);	
				return _WhiteBalance;
			}

			set
			{
				_WhiteBalance = value;
				_videoProc.Set(VideoProcAmpProperty.WhiteBalance , _WhiteBalance, _flag);
			}
		}

		public int BacklightCompensation
		{
			get
			{
				_videoProc.Get(VideoProcAmpProperty.BacklightCompensation , out _BacklightCompensation, out _flag);	
				return _BacklightCompensation;
			}

			set
			{
				_BacklightCompensation = value;
				_videoProc.Set(VideoProcAmpProperty.BacklightCompensation , _BacklightCompensation, _flag);
			}
		}

		public int ColorEnable
		{
			get
			{
				_videoProc.Get(VideoProcAmpProperty.ColorEnable, out _ColorEnable, out _flag);
				return _ColorEnable;
			}

			set
			{

				_ColorEnable = value;
				_videoProc.Set(VideoProcAmpProperty.ColorEnable, _ColorEnable, _flag);	
			}
		}

		public void FlipVertical()
		{
			IPin pinOut;
			pinOut = _FilterGraphController.getDevicePin();
			_videoControl.SetMode(pinOut, VideoControlFlags.FlipVertical);

		}
		public void FlipHorizontal()
		{
			IPin pinOut;
			pinOut = _FilterGraphController.getDevicePin();
			_videoControl.SetMode(pinOut, VideoControlFlags.FlipHorizontal);
		}
		


		public enum videoProp
		{
			Brightness,
			Contrast,
			Hue,
			Saturation,
			Sharpness,
			Gamma,
			ColorEnable,
			WhiteBalance,
			BacklightCompensation,
			Gain
		}

	}
}
