using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

using System.Diagnostics;
using System.Drawing.Imaging;
using System.IO;
using tsai;
using GraphController;
using MT.Tracker.DataStructures;

namespace MTClient
{
	/// <summary>
	/// Zusammenfassung fr uscCalibration.
	/// </summary>
	public class uscCalibration : System.Windows.Forms.UserControl
	{
		

							// Farbe fr das Zoomfeld
//		Bitmap	_bitmapIn;							// Originalbild
//		Bitmap	_bitmapOut;							// Bearbeitetes Bild
//		int		_chessboard		= 1;				// Wrfelseite 1 bis 5
//		int		_Calibration.ImageX			= 0;				// Berechneter Weltkoordinatenpunkt
//		int		_Calibration.ImageY			= 0;
//		int		_cameratype		= 1;				// Kameratyp: 1=Logitech, 2=Sony DV
//		bool	_Calibration.Pictureloaded	= false;			// Ist ein Bild geladen?
//		bool	_Calibration.Calibrated		= false;			// Wurde schon kalibriert?
//		float	_deltaXleft		= 0;				// 
//		float	_deltaXright	= 0;
//		float	_deltaYleft		= 0;
//		float	_deltaYright	= 0;
//		static int _Squares		= 5;				// Anzahl Quadrate pro Zeile - 1
//		static int _Calibration.Intersections = (_Squares+1)*(_Squares+1);			// Anzahl Quadrate pro Wrfelseite
//		float[,] _Calibration.Corner		= new float[(int)(5*_Calibration.Intersections),5]; // Punkteliste mit x, y, z, u, v
//		float[,] _Calibration.Point			= new float[4,2];	// 4 Eckpunkte eines Schachbretts
//		int[,]	_Calibration.Axis			= new int[60,6];	// Weltkoordinatenachsen
//		int[,]	_Cube			= new int[8,2];		// Wrfel
//		double[,] _Calibration.Model3D		= new double[14,5];	// 3D-Modell
//		double[] _cameraposition= new double[3];	// Kameraposition
//		bool[] _calculated		= new bool[5];		// Ist diese Wrfelseite schon kalibriert?
//		tsai_converter _tsai;						// Tsai
		float	_zoomfactorX	= 1;
		float	_zoomfactorY	= 1;


		Brush	_mybrush;		
//		float[,] _Calibration.Bodypoint		= new float[13,2];	// Zuordnung FP-BP
//		
//		public event EventHandler GrabImage;

		private clsCalibration	_Calibration;

//		private FilterGraphController		_filterGraphController;
		private FeaturePointData _data;	//Stores all Featurepoint Data



		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.RadioButton rbtn_SonyDV;
		private System.Windows.Forms.RadioButton rbtn_Logitech;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label lbl_CameraPosition;
		private System.Windows.Forms.Button btn_LoadCalibFile;
		private System.Windows.Forms.NumericUpDown nUD_WorldZ;
		private System.Windows.Forms.NumericUpDown nUD_WorldY;
		private System.Windows.Forms.NumericUpDown nUD_WorldX;
		private System.Windows.Forms.Label lbl_ImageCoord;
		private System.Windows.Forms.Button btn_World2Image;
		private System.Windows.Forms.Label lbl_WorldCoord;
		private System.Windows.Forms.PictureBox pbox_Cube;
		private System.Windows.Forms.ListBox lbox_Corners;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label lbl_Thresholdvalue;
		private System.Windows.Forms.Label lbl_Coords;
		private System.Windows.Forms.TrackBar tbar_Threshold;
		private System.Windows.Forms.Label lbl_Points;
		private System.Windows.Forms.Button btn_Calibrate;
		private System.Windows.Forms.Button btn_ResetPicture;
		private System.Windows.Forms.Button btn_ResetGrid;
		private System.Windows.Forms.Button btn_LoadPicture;
		private System.Windows.Forms.PictureBox pbox_Zoom;
		private System.Windows.Forms.PictureBox pbox_Bitmap;
		private System.Windows.Forms.Button btn_grabPicture;
		private System.ComponentModel.IContainer components;

		public uscCalibration()
		{
			// Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
			InitializeComponent();

		}

		/// <summary> 
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#region Vom Komponenten-Designer generierter Code
		/// <summary> 
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(uscCalibration));
			this.components = new System.ComponentModel.Container();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.rbtn_SonyDV = new System.Windows.Forms.RadioButton();
			this.rbtn_Logitech = new System.Windows.Forms.RadioButton();
			this.label3 = new System.Windows.Forms.Label();
			this.lbl_CameraPosition = new System.Windows.Forms.Label();
			this.btn_LoadCalibFile = new System.Windows.Forms.Button();
			this.nUD_WorldZ = new System.Windows.Forms.NumericUpDown();
			this.nUD_WorldY = new System.Windows.Forms.NumericUpDown();
			this.nUD_WorldX = new System.Windows.Forms.NumericUpDown();
			this.lbl_ImageCoord = new System.Windows.Forms.Label();
			this.btn_World2Image = new System.Windows.Forms.Button();
			this.lbl_WorldCoord = new System.Windows.Forms.Label();
			this.pbox_Cube = new System.Windows.Forms.PictureBox();
			this.lbox_Corners = new System.Windows.Forms.ListBox();
			this.label1 = new System.Windows.Forms.Label();
			this.lbl_Thresholdvalue = new System.Windows.Forms.Label();
			this.lbl_Coords = new System.Windows.Forms.Label();
			this.tbar_Threshold = new System.Windows.Forms.TrackBar();
			this.lbl_Points = new System.Windows.Forms.Label();
			this.btn_Calibrate = new System.Windows.Forms.Button();
			this.btn_ResetPicture = new System.Windows.Forms.Button();
			this.btn_ResetGrid = new System.Windows.Forms.Button();
			this.btn_LoadPicture = new System.Windows.Forms.Button();
			this.pbox_Zoom = new System.Windows.Forms.PictureBox();
			this.pbox_Bitmap = new System.Windows.Forms.PictureBox();
			this.btn_grabPicture = new System.Windows.Forms.Button();
			this.groupBox1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.nUD_WorldZ)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.nUD_WorldY)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.nUD_WorldX)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.tbar_Threshold)).BeginInit();
			this.SuspendLayout();
			// 
			// groupBox1
			// 
			this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.groupBox1.Controls.Add(this.rbtn_SonyDV);
			this.groupBox1.Controls.Add(this.rbtn_Logitech);
			this.groupBox1.Location = new System.Drawing.Point(664, 272);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(128, 66);
			this.groupBox1.TabIndex = 76;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Kameramodell";
			// 
			// rbtn_SonyDV
			// 
			this.rbtn_SonyDV.Location = new System.Drawing.Point(8, 40);
			this.rbtn_SonyDV.Name = "rbtn_SonyDV";
			this.rbtn_SonyDV.Size = new System.Drawing.Size(115, 24);
			this.rbtn_SonyDV.TabIndex = 1;
			this.rbtn_SonyDV.Text = "Sony DV-Kamera";
			this.rbtn_SonyDV.CheckedChanged += new System.EventHandler(this.rbtn_SonyDV_CheckedChanged);
			// 
			// rbtn_Logitech
			// 
			this.rbtn_Logitech.Checked = true;
			this.rbtn_Logitech.Location = new System.Drawing.Point(8, 16);
			this.rbtn_Logitech.Name = "rbtn_Logitech";
			this.rbtn_Logitech.Size = new System.Drawing.Size(115, 24);
			this.rbtn_Logitech.TabIndex = 0;
			this.rbtn_Logitech.TabStop = true;
			this.rbtn_Logitech.Text = "Logitech Webcam";
			this.rbtn_Logitech.CheckedChanged += new System.EventHandler(this.rbtn_Logitech_CheckedChanged);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(512, 232);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(104, 23);
			this.label3.TabIndex = 75;
			this.label3.Text = "Kamerakoordinaten";
			this.label3.Visible = false;
			// 
			// lbl_CameraPosition
			// 
			this.lbl_CameraPosition.Location = new System.Drawing.Point(512, 256);
			this.lbl_CameraPosition.Name = "lbl_CameraPosition";
			this.lbl_CameraPosition.Size = new System.Drawing.Size(64, 40);
			this.lbl_CameraPosition.TabIndex = 74;
			this.lbl_CameraPosition.Text = "X:  ----       Y:  ----        Z:  ----";
			this.lbl_CameraPosition.Visible = false;
			// 
			// btn_LoadCalibFile
			// 
			this.btn_LoadCalibFile.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btn_LoadCalibFile.Location = new System.Drawing.Point(664, 400);
			this.btn_LoadCalibFile.Name = "btn_LoadCalibFile";
			this.btn_LoadCalibFile.Size = new System.Drawing.Size(128, 23);
			this.btn_LoadCalibFile.TabIndex = 73;
			this.btn_LoadCalibFile.Text = "Kalibdatei ffnen";
			this.btn_LoadCalibFile.Click += new System.EventHandler(this.btn_LoadCalibFile_Click);
			// 
			// nUD_WorldZ
			// 
			this.nUD_WorldZ.Location = new System.Drawing.Point(520, 200);
			this.nUD_WorldZ.Maximum = new System.Decimal(new int[] {
																	   10000,
																	   0,
																	   0,
																	   0});
			this.nUD_WorldZ.Minimum = new System.Decimal(new int[] {
																	   10000,
																	   0,
																	   0,
																	   -2147483648});
			this.nUD_WorldZ.Name = "nUD_WorldZ";
			this.nUD_WorldZ.Size = new System.Drawing.Size(56, 20);
			this.nUD_WorldZ.TabIndex = 72;
			this.nUD_WorldZ.Visible = false;
			// 
			// nUD_WorldY
			// 
			this.nUD_WorldY.Location = new System.Drawing.Point(520, 176);
			this.nUD_WorldY.Maximum = new System.Decimal(new int[] {
																	   10000,
																	   0,
																	   0,
																	   0});
			this.nUD_WorldY.Minimum = new System.Decimal(new int[] {
																	   10000,
																	   0,
																	   0,
																	   -2147483648});
			this.nUD_WorldY.Name = "nUD_WorldY";
			this.nUD_WorldY.Size = new System.Drawing.Size(56, 20);
			this.nUD_WorldY.TabIndex = 71;
			this.nUD_WorldY.Visible = false;
			// 
			// nUD_WorldX
			// 
			this.nUD_WorldX.Location = new System.Drawing.Point(520, 152);
			this.nUD_WorldX.Maximum = new System.Decimal(new int[] {
																	   10000,
																	   0,
																	   0,
																	   0});
			this.nUD_WorldX.Minimum = new System.Decimal(new int[] {
																	   10000,
																	   0,
																	   0,
																	   -2147483648});
			this.nUD_WorldX.Name = "nUD_WorldX";
			this.nUD_WorldX.Size = new System.Drawing.Size(56, 20);
			this.nUD_WorldX.TabIndex = 70;
			this.nUD_WorldX.Visible = false;
			// 
			// lbl_ImageCoord
			// 
			this.lbl_ImageCoord.Location = new System.Drawing.Point(966, 496);
			this.lbl_ImageCoord.Name = "lbl_ImageCoord";
			this.lbl_ImageCoord.Size = new System.Drawing.Size(40, 24);
			this.lbl_ImageCoord.TabIndex = 69;
			// 
			// btn_World2Image
			// 
			this.btn_World2Image.Location = new System.Drawing.Point(584, 152);
			this.btn_World2Image.Name = "btn_World2Image";
			this.btn_World2Image.Size = new System.Drawing.Size(45, 45);
			this.btn_World2Image.TabIndex = 68;
			this.btn_World2Image.Text = "World          to            Image";
			this.btn_World2Image.Visible = false;
			// 
			// lbl_WorldCoord
			// 
			this.lbl_WorldCoord.Font = new System.Drawing.Font("Microsoft Sans Serif", 14.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lbl_WorldCoord.Location = new System.Drawing.Point(488, 152);
			this.lbl_WorldCoord.Name = "lbl_WorldCoord";
			this.lbl_WorldCoord.Size = new System.Drawing.Size(25, 64);
			this.lbl_WorldCoord.TabIndex = 67;
			this.lbl_WorldCoord.Text = "X: Y: Z:";
			this.lbl_WorldCoord.Visible = false;
			// 
			// pbox_Cube
			// 
			this.pbox_Cube.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.pbox_Cube.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("pbox_Cube.BackgroundImage")));
			this.pbox_Cube.Location = new System.Drawing.Point(664, 136);
			this.pbox_Cube.Name = "pbox_Cube";
			this.pbox_Cube.Size = new System.Drawing.Size(128, 120);
			this.pbox_Cube.TabIndex = 66;
			this.pbox_Cube.TabStop = false;
			this.pbox_Cube.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pbox_Cube_MouseDown);
			// 
			// lbox_Corners
			// 
			this.lbox_Corners.HorizontalScrollbar = true;
			this.lbox_Corners.Location = new System.Drawing.Point(504, 376);
			this.lbox_Corners.Name = "lbox_Corners";
			this.lbox_Corners.ScrollAlwaysVisible = true;
			this.lbox_Corners.Size = new System.Drawing.Size(128, 82);
			this.lbox_Corners.TabIndex = 65;
			this.lbox_Corners.Visible = false;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(440, 424);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 16);
			this.label1.TabIndex = 64;
			this.label1.Text = "Threshold";
			this.label1.Visible = false;
			// 
			// lbl_Thresholdvalue
			// 
			this.lbl_Thresholdvalue.Location = new System.Drawing.Point(448, 448);
			this.lbl_Thresholdvalue.Name = "lbl_Thresholdvalue";
			this.lbl_Thresholdvalue.Size = new System.Drawing.Size(40, 16);
			this.lbl_Thresholdvalue.TabIndex = 62;
			this.lbl_Thresholdvalue.Text = "128";
			this.lbl_Thresholdvalue.Visible = false;
			// 
			// lbl_Coords
			// 
			this.lbl_Coords.Location = new System.Drawing.Point(0, 448);
			this.lbl_Coords.Name = "lbl_Coords";
			this.lbl_Coords.Size = new System.Drawing.Size(48, 32);
			this.lbl_Coords.TabIndex = 61;
			// 
			// tbar_Threshold
			// 
			this.tbar_Threshold.Enabled = false;
			this.tbar_Threshold.LargeChange = 32;
			this.tbar_Threshold.Location = new System.Drawing.Point(176, 424);
			this.tbar_Threshold.Maximum = 255;
			this.tbar_Threshold.Name = "tbar_Threshold";
			this.tbar_Threshold.Size = new System.Drawing.Size(256, 42);
			this.tbar_Threshold.TabIndex = 63;
			this.tbar_Threshold.TickFrequency = 32;
			this.tbar_Threshold.Value = 128;
			this.tbar_Threshold.Visible = false;
			// 
			// lbl_Points
			// 
			this.lbl_Points.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.lbl_Points.Location = new System.Drawing.Point(504, 312);
			this.lbl_Points.Name = "lbl_Points";
			this.lbl_Points.Size = new System.Drawing.Size(128, 50);
			this.lbl_Points.TabIndex = 60;
			this.lbl_Points.Visible = false;
			// 
			// btn_Calibrate
			// 
			this.btn_Calibrate.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btn_Calibrate.Enabled = false;
			this.btn_Calibrate.Location = new System.Drawing.Point(664, 456);
			this.btn_Calibrate.Name = "btn_Calibrate";
			this.btn_Calibrate.Size = new System.Drawing.Size(128, 23);
			this.btn_Calibrate.TabIndex = 58;
			this.btn_Calibrate.Text = "Kalibrieren";
			this.btn_Calibrate.Click += new System.EventHandler(this.btn_Calibrate_Click);
			// 
			// btn_ResetPicture
			// 
			this.btn_ResetPicture.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btn_ResetPicture.Enabled = false;
			this.btn_ResetPicture.Location = new System.Drawing.Point(232, 384);
			this.btn_ResetPicture.Name = "btn_ResetPicture";
			this.btn_ResetPicture.Size = new System.Drawing.Size(88, 23);
			this.btn_ResetPicture.TabIndex = 57;
			this.btn_ResetPicture.Text = "Reset Picture";
			this.btn_ResetPicture.Visible = false;
			this.btn_ResetPicture.Click += new System.EventHandler(this.btn_ResetPicture_Click);
			// 
			// btn_ResetGrid
			// 
			this.btn_ResetGrid.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btn_ResetGrid.Enabled = false;
			this.btn_ResetGrid.Location = new System.Drawing.Point(664, 424);
			this.btn_ResetGrid.Name = "btn_ResetGrid";
			this.btn_ResetGrid.Size = new System.Drawing.Size(128, 23);
			this.btn_ResetGrid.TabIndex = 56;
			this.btn_ResetGrid.Text = "Gitterpunkte lschen";
			this.btn_ResetGrid.Click += new System.EventHandler(this.btn_ResetGrid_Click);
			// 
			// btn_LoadPicture
			// 
			this.btn_LoadPicture.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btn_LoadPicture.Location = new System.Drawing.Point(664, 368);
			this.btn_LoadPicture.Name = "btn_LoadPicture";
			this.btn_LoadPicture.Size = new System.Drawing.Size(128, 23);
			this.btn_LoadPicture.TabIndex = 55;
			this.btn_LoadPicture.Text = "Bild ffnen";
			this.btn_LoadPicture.Click += new System.EventHandler(this.btn_LoadPicture_Click);
			// 
			// pbox_Zoom
			// 
			this.pbox_Zoom.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.pbox_Zoom.BackColor = System.Drawing.SystemColors.ControlText;
			this.pbox_Zoom.Location = new System.Drawing.Point(664, 0);
			this.pbox_Zoom.Name = "pbox_Zoom";
			this.pbox_Zoom.Size = new System.Drawing.Size(128, 128);
			this.pbox_Zoom.TabIndex = 54;
			this.pbox_Zoom.TabStop = false;
			this.pbox_Zoom.Paint += new System.Windows.Forms.PaintEventHandler(this.pbox_Zoom_Paint);
			// 
			// pbox_Bitmap
			// 
			this.pbox_Bitmap.BackColor = System.Drawing.SystemColors.ControlText;
			this.pbox_Bitmap.Cursor = System.Windows.Forms.Cursors.Cross;
			this.pbox_Bitmap.Location = new System.Drawing.Point(0, 0);
			this.pbox_Bitmap.Name = "pbox_Bitmap";
			this.pbox_Bitmap.Size = new System.Drawing.Size(640, 480);
			this.pbox_Bitmap.TabIndex = 53;
			this.pbox_Bitmap.TabStop = false;
			this.pbox_Bitmap.Paint += new System.Windows.Forms.PaintEventHandler(this.pbox_Bitmap_Paint);
			this.pbox_Bitmap.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pbox_Bitmap_MouseMove);
			this.pbox_Bitmap.MouseLeave += new System.EventHandler(this.pbox_Bitmap_MouseLeave);
			this.pbox_Bitmap.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pbox_Bitmap_MouseDown);
			// 
			// btn_grabPicture
			// 
			this.btn_grabPicture.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btn_grabPicture.Location = new System.Drawing.Point(664, 344);
			this.btn_grabPicture.Name = "btn_grabPicture";
			this.btn_grabPicture.Size = new System.Drawing.Size(128, 23);
			this.btn_grabPicture.TabIndex = 77;
			this.btn_grabPicture.Text = "aktuelles Bild grabben";
			this.btn_grabPicture.Click += new System.EventHandler(this.btn_grabPicture_Click);
			// 
			// uscCalibration
			// 
			this.Controls.Add(this.btn_grabPicture);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.lbl_CameraPosition);
			this.Controls.Add(this.btn_LoadCalibFile);
			this.Controls.Add(this.nUD_WorldZ);
			this.Controls.Add(this.nUD_WorldY);
			this.Controls.Add(this.nUD_WorldX);
			this.Controls.Add(this.lbl_ImageCoord);
			this.Controls.Add(this.btn_World2Image);
			this.Controls.Add(this.lbl_WorldCoord);
			this.Controls.Add(this.pbox_Cube);
			this.Controls.Add(this.lbox_Corners);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.lbl_Thresholdvalue);
			this.Controls.Add(this.lbl_Coords);
			this.Controls.Add(this.tbar_Threshold);
			this.Controls.Add(this.lbl_Points);
			this.Controls.Add(this.btn_Calibrate);
			this.Controls.Add(this.btn_ResetPicture);
			this.Controls.Add(this.btn_ResetGrid);
			this.Controls.Add(this.btn_LoadPicture);
			this.Controls.Add(this.pbox_Zoom);
			this.Controls.Add(this.pbox_Bitmap);
			this.Name = "uscCalibration";
			this.Size = new System.Drawing.Size(808, 480);
			this.groupBox1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.nUD_WorldZ)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.nUD_WorldY)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.nUD_WorldX)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.tbar_Threshold)).EndInit();
			this.ResumeLayout(false);

		}

		#endregion

		public void Initalize(FilterGraphController filterGraphController, clsTracker Tracker, clsCalibration Calibration)
		{
			_Calibration = Calibration;
			_Calibration.UpdateCorner += new MTClient.clsCalibration.UpdateCornerDelegate(UpdateCorner);
			_Calibration.UpdateCameraPosition += new MTClient.clsCalibration.UpdateCameraPositionDelegate(UpdateCameraPosition);
			_Calibration.UpdatePicture += new MTClient.clsCalibration.UpdatePictureDelegate(UpdatePicture);
			
			_Calibration.InitializeVariables();

			Tracker.NewFrame += new clsTracker.NewFrameDelegate(_Tracker_NewFrame);
		}


		private void _Tracker_NewFrame(FeaturePointData Data)
		{
			_data = Data;
		}

		

// ToDo: ++++++++++++++

		private void UpdateCorner(float[,]corner)
		{

			// Listbox mit den gltigen Punkten auffllen
			lbox_Corners.Items.Clear();
			for (int k=0; k<corner.GetLength(0); k++)
			{
				if (corner[k,3] != -1)
				{				
					lbox_Corners.Items.Add(String.Concat("P",k,": ", corner[k,3].ToString()," / ",	corner[k,4].ToString()) );				
				}
			}	

			//this.Refresh();
		}


		private void UpdateCameraPosition(double[] cameraposition)
		{
			lbl_CameraPosition.Text = String.Concat(
				  "X: ",((int)cameraposition[0]).ToString(),
				"\nY: ",((int)cameraposition[1]).ToString(),
				"\nZ: ",((int)cameraposition[2]).ToString());
		}	


		private void UpdatePicture(Bitmap b)
		{
			_zoomfactorX = b.Width  / pbox_Bitmap.Width;
			_zoomfactorY = b.Height / pbox_Bitmap.Height;

			pbox_Bitmap.SizeMode = PictureBoxSizeMode.StretchImage;
			pbox_Bitmap.Image = b;

			this.Refresh();
	
		}


		private void pbox_Bitmap_Paint(object sender, PaintEventArgs e) 
		{
			if (_Calibration == null) { return; }

				int i = 0;
				try
				{
					Pen mypenCyan = new Pen(Color.Cyan);
					Pen mypenRed  = new Pen(Color.Red);

					// Falls kalibriert wurde wird ein Achsenkreuz und der Wrfel gezeichnet
					if (_Calibration.Calibrated)
					{
						for (int j=0; j<_Calibration.Axis.GetLength(0)-1; j++)
						{
							if (_Calibration.Axis[j,0] != 0 && _Calibration.Axis[j+1,0] != 0)
							{
								e.Graphics.DrawLine(mypenRed,_Calibration.Axis[j,0]/_zoomfactorX,_Calibration.Axis[j,1]/_zoomfactorY,_Calibration.Axis[j+1,0]/_zoomfactorX,_Calibration.Axis[j+1,1]/_zoomfactorY);
							}
							if (_Calibration.Axis[j,2] != 0  && _Calibration.Axis[j+1,2] != 0)
							{
								e.Graphics.DrawLine(mypenRed,_Calibration.Axis[j,2]/_zoomfactorX,_Calibration.Axis[j,3]/_zoomfactorY,_Calibration.Axis[j+1,2]/_zoomfactorX,_Calibration.Axis[j+1,3]/_zoomfactorY);
							}
							if (_Calibration.Axis[j,4] != 0 && _Calibration.Axis[j+1,4] != 0)
							{
								e.Graphics.DrawLine(mypenRed,_Calibration.Axis[j,4]/_zoomfactorX,_Calibration.Axis[j,5]/_zoomfactorY,_Calibration.Axis[j+1,4]/_zoomfactorX,_Calibration.Axis[j+1,5]/_zoomfactorY);
							}
						}

						//Wrfel
						if ( _Calibration.Cube[0,0] != 0)
						{
							e.Graphics.DrawLine(mypenRed,_Calibration.Cube[0,0]/_zoomfactorX,_Calibration.Cube[0,1]/_zoomfactorY,_Calibration.Cube[1,0]/_zoomfactorX,_Calibration.Cube[1,1]/_zoomfactorY);
							e.Graphics.DrawLine(mypenRed,_Calibration.Cube[1,0]/_zoomfactorX,_Calibration.Cube[1,1]/_zoomfactorY,_Calibration.Cube[2,0]/_zoomfactorX,_Calibration.Cube[2,1]/_zoomfactorY);
							e.Graphics.DrawLine(mypenRed,_Calibration.Cube[2,0]/_zoomfactorX,_Calibration.Cube[2,1]/_zoomfactorY,_Calibration.Cube[3,0]/_zoomfactorX,_Calibration.Cube[3,1]/_zoomfactorY);
							e.Graphics.DrawLine(mypenRed,_Calibration.Cube[3,0]/_zoomfactorX,_Calibration.Cube[3,1]/_zoomfactorY,_Calibration.Cube[0,0]/_zoomfactorX,_Calibration.Cube[0,1]/_zoomfactorY);

							e.Graphics.DrawLine(mypenRed,_Calibration.Cube[0,0]/_zoomfactorX,_Calibration.Cube[0,1]/_zoomfactorY,_Calibration.Cube[4,0]/_zoomfactorX,_Calibration.Cube[4,1]/_zoomfactorY);
							e.Graphics.DrawLine(mypenRed,_Calibration.Cube[1,0]/_zoomfactorX,_Calibration.Cube[1,1]/_zoomfactorY,_Calibration.Cube[5,0]/_zoomfactorX,_Calibration.Cube[5,1]/_zoomfactorY);
							e.Graphics.DrawLine(mypenRed,_Calibration.Cube[2,0]/_zoomfactorX,_Calibration.Cube[2,1]/_zoomfactorY,_Calibration.Cube[6,0]/_zoomfactorX,_Calibration.Cube[6,1]/_zoomfactorY);
							e.Graphics.DrawLine(mypenRed,_Calibration.Cube[3,0]/_zoomfactorX,_Calibration.Cube[3,1]/_zoomfactorY,_Calibration.Cube[7,0]/_zoomfactorX,_Calibration.Cube[7,1]/_zoomfactorY);

							e.Graphics.DrawLine(mypenRed,_Calibration.Cube[4,0]/_zoomfactorX,_Calibration.Cube[4,1]/_zoomfactorY,_Calibration.Cube[5,0]/_zoomfactorX,_Calibration.Cube[5,1]/_zoomfactorY);
							e.Graphics.DrawLine(mypenRed,_Calibration.Cube[5,0]/_zoomfactorX,_Calibration.Cube[5,1]/_zoomfactorY,_Calibration.Cube[6,0]/_zoomfactorX,_Calibration.Cube[6,1]/_zoomfactorY);
							e.Graphics.DrawLine(mypenRed,_Calibration.Cube[6,0]/_zoomfactorX,_Calibration.Cube[6,1]/_zoomfactorY,_Calibration.Cube[7,0]/_zoomfactorX,_Calibration.Cube[7,1]/_zoomfactorY);
							e.Graphics.DrawLine(mypenRed,_Calibration.Cube[7,0]/_zoomfactorX,_Calibration.Cube[7,1]/_zoomfactorY,_Calibration.Cube[4,0]/_zoomfactorX,_Calibration.Cube[4,1]/_zoomfactorY);
						}

						// Berechneter ImagePunkt aus den Weltkoordinaten zeichnen
						if (_Calibration.ImageX != 0)
						{
							e.Graphics.DrawEllipse(mypenCyan,_Calibration.ImageX-5,_Calibration.ImageY-5,10,10);
							e.Graphics.DrawLine(mypenCyan,_Calibration.ImageX-5,_Calibration.ImageY,_Calibration.ImageX+5,_Calibration.ImageY);
							e.Graphics.DrawLine(mypenCyan,_Calibration.ImageX,_Calibration.ImageY-5,_Calibration.ImageX,_Calibration.ImageY+5);
						}

						// 3D-Modell
//						if (_Calibration.Model3D[0,3] != 0)
//						{
//							for (int j=0; j<_Calibration.Model3D.GetLength(0)-1; j++)
//							{
//								e.Graphics.DrawEllipse(mypenCyan, (float)(_Calibration.Model3D[j,3]-6)/_zoomfactorX, (float)(_Calibration.Model3D[j,4]-6)/_zoomfactorY, 12, 12);
//							}
//							e.Graphics.DrawLine(mypenRed, (float)_Calibration.Model3D[0,3]/_zoomfactorX, (float)_Calibration.Model3D[0,4]/_zoomfactorY, (float)_Calibration.Model3D[4,3]/_zoomfactorX, (float)_Calibration.Model3D[4,4]/_zoomfactorY); //linker Unterarm 
//							e.Graphics.DrawLine(mypenRed, (float)_Calibration.Model3D[4,3]/_zoomfactorX, (float)_Calibration.Model3D[4,4]/_zoomfactorY, (float)_Calibration.Model3D[9,3]/_zoomfactorX, (float)_Calibration.Model3D[9,4]/_zoomfactorY); //linker Oberarm
//							e.Graphics.DrawLine(mypenRed, (float)_Calibration.Model3D[9,3]/_zoomfactorX, (float)_Calibration.Model3D[9,4]/_zoomfactorY, (float)_Calibration.Model3D[5,3]/_zoomfactorX, (float)_Calibration.Model3D[5,4]/_zoomfactorY); //Schulter
//							e.Graphics.DrawLine(mypenRed, (float)_Calibration.Model3D[5,3]/_zoomfactorX, (float)_Calibration.Model3D[5,4]/_zoomfactorY, (float)_Calibration.Model3D[10,3]/_zoomfactorX, (float)_Calibration.Model3D[10,4]/_zoomfactorY); //rechter Oberarm
//							e.Graphics.DrawLine(mypenRed, (float)_Calibration.Model3D[10,3]/_zoomfactorX, (float)_Calibration.Model3D[10,4]/_zoomfactorY, (float)_Calibration.Model3D[1,3]/_zoomfactorX, (float)_Calibration.Model3D[1,4]/_zoomfactorY); //rechter Unterarm
//							e.Graphics.DrawLine(mypenRed, (float)_Calibration.Model3D[9,3]/_zoomfactorX, (float)_Calibration.Model3D[9,4]/_zoomfactorY, (float)_Calibration.Model3D[11,3]/_zoomfactorX, (float)_Calibration.Model3D[11,4]/_zoomfactorY); //linke Seite
//							e.Graphics.DrawLine(mypenRed, (float)_Calibration.Model3D[5,3]/_zoomfactorX, (float)_Calibration.Model3D[5,4]/_zoomfactorY, (float)_Calibration.Model3D[2,3]/_zoomfactorX, (float)_Calibration.Model3D[2,4]/_zoomfactorY); //rechte Seite
//							e.Graphics.DrawLine(mypenRed, (float)_Calibration.Model3D[11,3]/_zoomfactorX, (float)_Calibration.Model3D[11,4]/_zoomfactorY, (float)_Calibration.Model3D[2,3]/_zoomfactorX, (float)_Calibration.Model3D[2,4]/_zoomfactorY); //Hfte
//							e.Graphics.DrawLine(mypenRed, (float)_Calibration.Model3D[11,3]/_zoomfactorX, (float)_Calibration.Model3D[11,4]/_zoomfactorY, (float)_Calibration.Model3D[6,3]/_zoomfactorX, (float)_Calibration.Model3D[6,4]/_zoomfactorY); //linker Oberschenkel
//							e.Graphics.DrawLine(mypenRed, (float)_Calibration.Model3D[2,3]/_zoomfactorX, (float)_Calibration.Model3D[2,4]/_zoomfactorY, (float)_Calibration.Model3D[12,3]/_zoomfactorX, (float)_Calibration.Model3D[12,4]/_zoomfactorY); //rechter Oberschenkel
//							e.Graphics.DrawLine(mypenRed, (float)_Calibration.Model3D[6,3]/_zoomfactorX, (float)_Calibration.Model3D[6,4]/_zoomfactorY, (float)_Calibration.Model3D[3,3]/_zoomfactorX, (float)_Calibration.Model3D[3,4]/_zoomfactorY); //linker Unterschenkel
//							e.Graphics.DrawLine(mypenRed, (float)_Calibration.Model3D[12,3]/_zoomfactorX, (float)_Calibration.Model3D[12,4]/_zoomfactorY, (float)_Calibration.Model3D[7,3]/_zoomfactorX, (float)_Calibration.Model3D[7,4]/_zoomfactorY); //rechter Unterschenkel
//							e.Graphics.DrawLine(mypenRed, (float)_Calibration.Model3D[8,3]/_zoomfactorX, (float)_Calibration.Model3D[8,4]/_zoomfactorY, (float)_Calibration.Model3D[13,3]/_zoomfactorX, (float)_Calibration.Model3D[13,4]/_zoomfactorY); //Hals						
//						}
					}

					while(i < 4 && _Calibration.Point[i,0] != -1)
					{
						e.Graphics.DrawEllipse(mypenCyan,_Calibration.Point[i,0]/_zoomfactorX-5,
														 _Calibration.Point[i,1]/_zoomfactorY-5,10,10);
						i++;
					
						if (i==4)
						{

							// Gitter zeichnen
							//							for (int m=0; m<=_Squares; m++)
							//							{
							//								for (int n=0; n<5; n++)
							//								{
							//									if (_Calibration.Corner[n*_Calibration.Intersections,3] != -1)
							//									{
							//										//Vertical
							//										e.Graphics.DrawLine(mypenRed, _Calibration.Corner[(n*_Calibration.Intersections)+m,3],
							//											_Calibration.Corner[(n*_Calibration.Intersections)+m,4],
							//											_Calibration.Corner[(n*_Calibration.Intersections)+m+(_Calibration.Intersections-_Squares-1),3],
							//											_Calibration.Corner[(n*_Calibration.Intersections)+m+(_Calibration.Intersections-_Squares-1),4]); 
							//										//Horizontal	
							//										e.Graphics.DrawLine(mypenRed, _Calibration.Corner[(n*_Calibration.Intersections)+m*(_Squares+1),3],
							//											_Calibration.Corner[(n*_Calibration.Intersections)+m*(_Squares+1),4],
							//											_Calibration.Corner[(n*_Calibration.Intersections)+m*(_Squares+1)+_Squares,3],
							//											_Calibration.Corner[(n*_Calibration.Intersections)+m*(_Squares+1)+_Squares,4]); 
							//									}
							//								}
							//							}


							// Eckpunkte zeichnen
							for (int m=0; m<_Calibration.Intersections; m++)
							{
								for (int n=0; n<5; n++)
								{
									if (_Calibration.Corner[n*_Calibration.Intersections+m,3] != -1)
									{
										e.Graphics.DrawEllipse(mypenCyan,_Calibration.Corner[n*_Calibration.Intersections+m,3]/_zoomfactorX-2,
																		 _Calibration.Corner[n*_Calibration.Intersections+m,4]/_zoomfactorY-2,4,4);
									}
								}
							}										
						}
					}
				}
				catch{Console.WriteLine("zuviel rausgeloescht");}
//			}
		}


		private void pbox_Bitmap_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{

			if (_Calibration.Pictureloaded)
				try
				{	int thumbSize = 15;
					int x = (int)(Math.Min(Math.Max(0,_zoomfactorX * e.X-thumbSize/2),pbox_Bitmap.Image.Width-thumbSize));
					int y = (int)(Math.Min(Math.Max(0,_zoomfactorY * e.Y-thumbSize/2),pbox_Bitmap.Image.Height-thumbSize));
					int w = thumbSize;
					int h = thumbSize;

					_mybrush = new System.Drawing.TextureBrush(pbox_Bitmap.Image,new Rectangle(x, y, w, h));
					pbox_Zoom.Image    = ((TextureBrush)_mybrush).Image;
					pbox_Zoom.SizeMode = PictureBoxSizeMode.StretchImage;
					this.Refresh();
				}
				catch{}

			//Koordinaten in Label anzeigen
			lbl_Coords.Text = String.Concat("u: ", ((int)(_zoomfactorX * e.X)).ToString(),"\nv: ", ((int)(_zoomfactorY * e.Y)).ToString());			
		}


		private void pbox_Bitmap_MouseLeave(object sender, System.EventArgs e)
		{
			lbl_Coords.Text = String.Concat("u: ---\nv: ---");
		}


		private void pbox_Bitmap_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if(_Calibration.Pictureloaded)
			{
				try
				{
					int i = 0;
					
					while(_Calibration.Point[i,0] != -1 && i < 4)
					{
						i++;
					}
						
					if(i < 4)
					{
						_Calibration.Point[i,0] = _zoomfactorX * e.X;
						_Calibration.Point[i,1] = _zoomfactorY * e.Y;
					}
					if(i==3)
					{
						// Eckpunkte berechnen falls ntig
						if (!_Calibration.Calculated[_Calibration.Chessboard-1])
						{
							_Calibration.calculateCorners();
						}
						btn_Calibrate.Enabled = _Calibration.readyToCalibrate();			
					}
					

					//_mousedown = true;
					lbl_Points.Text = String.Concat("P1: ",_Calibration.Point[0,0].ToString()," / ",_Calibration.Point[0,1].ToString(),
						"\nP2: ",_Calibration.Point[1,0].ToString()," / ",_Calibration.Point[1,1].ToString(),
						"\nP3: ",_Calibration.Point[2,0].ToString()," / ",_Calibration.Point[2,1].ToString(),
						"\nP4: ",_Calibration.Point[3,0].ToString()," / ",_Calibration.Point[3,1].ToString());


					this.Refresh();
				}
				catch{}
			}
		}


		private void pbox_Bitmap_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if(_Calibration.Pictureloaded)
			{
				try
				{
					//_mousedown = false;
				}
				catch{}
			}
		}


		private void pbox_Zoom_Paint(object sender, PaintEventArgs e)
		{
			if (_Calibration == null) { return; }

			Pen mypen  = new Pen(Color.LawnGreen);
			if (_Calibration.Pictureloaded) 
			{
				
//				//Fadenkreuz zeichnen
				e.Graphics.DrawLine(mypen, new Point(0,64), new Point(128,64));
				e.Graphics.DrawLine(mypen, new Point(64,0), new Point(64,128)); 
			}
		}
		

		private void btn_LoadPicture_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog _image = new OpenFileDialog(); //OpenFileDialog image
			_image.Title = "Select image (640x480) for calibration..."; //Titel des OpenFileDialogs image
			_image.Filter = "Image Files (*.jpg *.bmp *.tif *.gif)|*.jpg; *.bmp; *.tif; *.gif|All File Types (*.*)|*.*"; //const string fFilter wird hier als Filter dem image zugewiesen			
			
			if(_image.ShowDialog() == DialogResult.OK)		//Abfrage: Kann ein Bild geffnet werden?
			{
				_Calibration.LoadPicture(_image.FileName);
				
				//pbox_Bitmap.Size = new System.Drawing.Size(_bitmapIn.Width, _bitmapIn.Height);

				pbox_Bitmap.SizeMode = PictureBoxSizeMode.StretchImage;
				pbox_Bitmap.Image = _Calibration.BitmapIn;

				
				btn_ResetPicture.Enabled = true;
				btn_ResetGrid.Enabled	 = true;
				tbar_Threshold.Enabled	 = true;
			}

			lbl_Points.Text			= "";
			btn_Calibrate.Enabled	= _Calibration.readyToCalibrate();

//			_calculated[_chessboard-1]= false;
//			readyToCalibrate();
			lbox_Corners.Items.Clear();
		}


		private void btn_ResetGrid_Click(object sender, System.EventArgs e)
		{
			_Calibration.ResetGrid();
			
			lbl_Points.Text			= "";
			lbox_Corners.Items.Clear();
			btn_Calibrate.Enabled	= _Calibration.readyToCalibrate();			
			btn_ResetPicture_Click(sender, e);
		}


		private void btn_ResetPicture_Click(object sender, System.EventArgs e)
		{
			_Calibration.ResetPicture();
		}


		private void btn_Calibrate_Click(object sender, System.EventArgs e)
		{
			_Calibration.Calibrate();
			_Calibration.ResetPicture();
			_Calibration.calc3D();
			this.Refresh();
		}


		private void btn_LoadCalibFile_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog calibfile = new OpenFileDialog();
			calibfile.Title			 = "Select Tsai CalibFile";
			calibfile.Filter		 = "Calib Files (*.dat)|*.dat|All File Types (*.*)|*.*";			
			
			if(calibfile.ShowDialog() == DialogResult.OK)
			{
				_Calibration.LoadCalibFile(calibfile.FileName, eTsaiOrientation.x);
			}
			this.Refresh();
		}


		private void rbtn_Logitech_CheckedChanged(object sender, System.EventArgs e)
		{
			if( rbtn_Logitech.Checked) {_Calibration.Cameratype = 1;}
		}


		private void rbtn_SonyDV_CheckedChanged(object sender, System.EventArgs e)
		{
			if( rbtn_SonyDV.Checked) {_Calibration.Cameratype = 2;}
		}


		private void pbox_Cube_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			int[,] side = new int[5,2];		
			side[0,0] = 18;
			side[0,1] = 111;
			side[1,0] = 124;
			side[1,1] = 61;
			side[2,0] = 113;
			side[2,1] = 5;
			side[3,0] = 12;
			side[3,1] = 67;
			side[4,0] = 62;
			side[4,1] = 10;

			int min = 999999999;
			int tmp = 0;
			int i = 0;
			for(i=0; i<5; i++)
			{
				tmp = Math.Abs(side[i,0]-e.X)+Math.Abs(side[i,1]-e.Y);
				if( tmp < min)
				{
					min = tmp;
					_Calibration.Chessboard = i+1;
				}			
			}
			
			System.Console.WriteLine(String.Concat("Seite ", _Calibration.Chessboard.ToString()));
		}


		private void btn_grabPicture_Click(object sender, System.EventArgs e)
		{
			_Calibration.GrabPicture();

			btn_ResetPicture.Enabled = true;
			btn_ResetGrid.Enabled	 = true;
			tbar_Threshold.Enabled	 = true;

		}

//		private void btn_World2Image_Click(object sender, System.EventArgs e)
//		{
//			if (_Calibration.Calibrated)
//			{
//				double x = new double();
//				double y = new double();
//				_tsai.world_coord_to_image_coord((double)nUD_WorldX.Value,
//					(double)nUD_WorldY.Value,
//					(double)nUD_WorldZ.Value,
//					ref x,
//					ref y);
//
//				_Calibration.ImageX = (int)x;
//				_Calibration.ImageY = (int)y;
//						
//				for (int i = 0 ; i < _Calibration.Point.GetLength(0); i++)
//				{ 
//					_Calibration.Point[i,0] = -1;
//					_Calibration.Point[i,1] = -1;
//				}
//				
//				lbl_ImageCoord.Text = String.Concat("u: ",_Calibration.ImageX.ToString(),"\nv: ",_Calibration.ImageY.ToString());
//				this.Refresh();
//			}
//		}	


//		private void tbar_Threshold_Scroll(object sender, System.EventArgs e)
//		{
//			lbl_Thresholdvalue.Text = tbar_Threshold.Value.ToString();
//			if(_Calibration.Pictureloaded)
//			{
//				pbox_Bitmap.Image = null;
//				pbox_Bitmap.Image = ConvertToBinary(_bitmapIn, tbar_Threshold.Value);
//			}
//			this.Refresh();
//		}


	}
}
