using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using GraphController;

namespace MTClient
{
	/// <summary>
	/// Zusammenfassung fr uscCapture.
	/// </summary>
	public class uscCapture : System.Windows.Forms.UserControl
	{
		//declare Event Delegates
		public delegate void NewFrameRateDelegate(string message);
		public delegate void NewResolutionDelegate(string message);


		//declare Events
		public event NewFrameRateDelegate NewFrameRate;
		public event NewResolutionDelegate NewResolution;
		
		private clsCapture _Capture;
		private FilterGraphController _filterGraphController = null;
		private Filters filters = new Filters();

		protected System.Windows.Forms.Label lblPath;
		protected System.Windows.Forms.Button btnStop;
		protected System.Windows.Forms.Button btnRecord;
		protected System.Windows.Forms.Button btnChoose;
		protected System.Windows.Forms.Panel capturePanel;
		protected System.Windows.Forms.Label lblVideoCapatiblities;
		protected System.Windows.Forms.TextBox txtFilename;
		protected System.Windows.Forms.Label lblCompressor;
		protected System.Windows.Forms.ListBox lstCompressor;
		protected System.Windows.Forms.ComboBox cmbFramerate;
		protected System.Windows.Forms.ComboBox cmbResolution;
		protected System.Windows.Forms.Label lblFramerate;
		protected System.Windows.Forms.Label lblResolution;
		protected System.Windows.Forms.ListBox lstProperties;
		protected System.Windows.Forms.Label lblProperties;
		private System.ComponentModel.IContainer components=null;

		public uscCapture()
		{
			// Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
			InitializeComponent();

			// TODO: Initialisierungen nach dem Aufruf von InitializeComponent hinzufgen

		}

		/// <summary> 
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Komponenten-Designer generierter Code
		/// <summary> 
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(uscCapture));
			this.btnStop = new System.Windows.Forms.Button();
			this.btnRecord = new System.Windows.Forms.Button();
			this.btnChoose = new System.Windows.Forms.Button();
			this.lblPath = new System.Windows.Forms.Label();
			this.capturePanel = new System.Windows.Forms.Panel();
			this.lblVideoCapatiblities = new System.Windows.Forms.Label();
			this.txtFilename = new System.Windows.Forms.TextBox();
			this.lblCompressor = new System.Windows.Forms.Label();
			this.lstCompressor = new System.Windows.Forms.ListBox();
			this.cmbFramerate = new System.Windows.Forms.ComboBox();
			this.cmbResolution = new System.Windows.Forms.ComboBox();
			this.lblFramerate = new System.Windows.Forms.Label();
			this.lblResolution = new System.Windows.Forms.Label();
			this.lstProperties = new System.Windows.Forms.ListBox();
			this.lblProperties = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// btnStop
			// 
			this.btnStop.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnStop.Image = ((System.Drawing.Image)(resources.GetObject("btnStop.Image")));
			this.btnStop.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.btnStop.Location = new System.Drawing.Point(816, 456);
			this.btnStop.Name = "btnStop";
			this.btnStop.Size = new System.Drawing.Size(72, 24);
			this.btnStop.TabIndex = 12;
			this.btnStop.Text = "Stop";
			this.btnStop.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.btnStop.Click += new System.EventHandler(this.btnStop_Click);
			// 
			// btnRecord
			// 
			this.btnRecord.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnRecord.Image = ((System.Drawing.Image)(resources.GetObject("btnRecord.Image")));
			this.btnRecord.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.btnRecord.Location = new System.Drawing.Point(736, 456);
			this.btnRecord.Name = "btnRecord";
			this.btnRecord.Size = new System.Drawing.Size(72, 24);
			this.btnRecord.TabIndex = 11;
			this.btnRecord.Text = "Record";
			this.btnRecord.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.btnRecord.Click += new System.EventHandler(this.btnRecord_Click);
			// 
			// btnChoose
			// 
			this.btnChoose.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.btnChoose.Location = new System.Drawing.Point(648, 32);
			this.btnChoose.Name = "btnChoose";
			this.btnChoose.Size = new System.Drawing.Size(240, 24);
			this.btnChoose.TabIndex = 10;
			this.btnChoose.Text = "Verzeichnis whlen";
			this.btnChoose.Click += new System.EventHandler(this.btnChoose_Click);
			// 
			// lblPath
			// 
			this.lblPath.Location = new System.Drawing.Point(648, 8);
			this.lblPath.Name = "lblPath";
			this.lblPath.Size = new System.Drawing.Size(32, 16);
			this.lblPath.TabIndex = 8;
			this.lblPath.Text = "Pfad:";
			// 
			// capturePanel
			// 
			this.capturePanel.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.capturePanel.Location = new System.Drawing.Point(0, 0);
			this.capturePanel.Name = "capturePanel";
			this.capturePanel.Size = new System.Drawing.Size(640, 480);
			this.capturePanel.TabIndex = 22;
			// 
			// lblVideoCapatiblities
			// 
			this.lblVideoCapatiblities.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lblVideoCapatiblities.Location = new System.Drawing.Point(656, 344);
			this.lblVideoCapatiblities.Name = "lblVideoCapatiblities";
			this.lblVideoCapatiblities.Size = new System.Drawing.Size(232, 112);
			this.lblVideoCapatiblities.TabIndex = 24;
			// 
			// txtFilename
			// 
			this.txtFilename.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtFilename.Location = new System.Drawing.Point(688, 8);
			this.txtFilename.Name = "txtFilename";
			this.txtFilename.Size = new System.Drawing.Size(200, 20);
			this.txtFilename.TabIndex = 25;
			this.txtFilename.Text = "c:\\capture.avi";
			// 
			// lblCompressor
			// 
			this.lblCompressor.Location = new System.Drawing.Point(648, 112);
			this.lblCompressor.Name = "lblCompressor";
			this.lblCompressor.Size = new System.Drawing.Size(112, 16);
			this.lblCompressor.TabIndex = 31;
			this.lblCompressor.Text = "Kompressions Filter:";
			// 
			// lstCompressor
			// 
			this.lstCompressor.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lstCompressor.Location = new System.Drawing.Point(648, 128);
			this.lstCompressor.Name = "lstCompressor";
			this.lstCompressor.Size = new System.Drawing.Size(240, 121);
			this.lstCompressor.TabIndex = 30;
			this.lstCompressor.SelectedIndexChanged += new System.EventHandler(this.lstCompressor_SelectedIndexChanged);
			// 
			// cmbFramerate
			// 
			this.cmbFramerate.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.cmbFramerate.Location = new System.Drawing.Point(728, 88);
			this.cmbFramerate.Name = "cmbFramerate";
			this.cmbFramerate.Size = new System.Drawing.Size(160, 21);
			this.cmbFramerate.TabIndex = 40;
			this.cmbFramerate.Text = "None";
			this.cmbFramerate.SelectedIndexChanged += new System.EventHandler(this.cmbFramerate_SelectedIndexChanged);
			// 
			// cmbResolution
			// 
			this.cmbResolution.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.cmbResolution.Location = new System.Drawing.Point(728, 64);
			this.cmbResolution.Name = "cmbResolution";
			this.cmbResolution.Size = new System.Drawing.Size(160, 21);
			this.cmbResolution.TabIndex = 39;
			this.cmbResolution.Text = "None";
			this.cmbResolution.SelectedIndexChanged += new System.EventHandler(this.cmbResolution_SelectedIndexChanged);
			// 
			// lblFramerate
			// 
			this.lblFramerate.Location = new System.Drawing.Point(648, 88);
			this.lblFramerate.Name = "lblFramerate";
			this.lblFramerate.Size = new System.Drawing.Size(64, 16);
			this.lblFramerate.TabIndex = 38;
			this.lblFramerate.Text = "Framerate:";
			// 
			// lblResolution
			// 
			this.lblResolution.Location = new System.Drawing.Point(648, 64);
			this.lblResolution.Name = "lblResolution";
			this.lblResolution.Size = new System.Drawing.Size(64, 16);
			this.lblResolution.TabIndex = 37;
			this.lblResolution.Text = "Auflsung:";
			// 
			// lstProperties
			// 
			this.lstProperties.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lstProperties.Location = new System.Drawing.Point(648, 272);
			this.lstProperties.Name = "lstProperties";
			this.lstProperties.Size = new System.Drawing.Size(240, 69);
			this.lstProperties.TabIndex = 43;
			this.lstProperties.SelectedIndexChanged += new System.EventHandler(this.lstProperties_SelectedIndexChanged);
			// 
			// lblProperties
			// 
			this.lblProperties.Location = new System.Drawing.Point(648, 256);
			this.lblProperties.Name = "lblProperties";
			this.lblProperties.Size = new System.Drawing.Size(80, 16);
			this.lblProperties.TabIndex = 44;
			this.lblProperties.Text = "Eigenschaften:";
			// 
			// uscCapture
			// 
			this.Controls.Add(this.lstProperties);
			this.Controls.Add(this.lblProperties);
			this.Controls.Add(this.cmbFramerate);
			this.Controls.Add(this.cmbResolution);
			this.Controls.Add(this.lblFramerate);
			this.Controls.Add(this.lblResolution);
			this.Controls.Add(this.lblCompressor);
			this.Controls.Add(this.lstCompressor);
			this.Controls.Add(this.lblVideoCapatiblities);
			this.Controls.Add(this.capturePanel);
			this.Controls.Add(this.btnStop);
			this.Controls.Add(this.btnRecord);
			this.Controls.Add(this.btnChoose);
			this.Controls.Add(this.lblPath);
			this.Controls.Add(this.txtFilename);
			this.Name = "uscCapture";
			this.Size = new System.Drawing.Size(888, 488);
			this.ResumeLayout(false);

		}
		#endregion

		public void Initalize(FilterGraphController filterGraphController, Filters filters)
		{
			Filter f;
			PropertyPage p;
			_filterGraphController = filterGraphController;
			_Capture = new clsCapture(_filterGraphController);
			// Load video compressors
			try
			{
				lstCompressor.Items.Clear();
				lstCompressor.Items.Add("(None)");
				lstCompressor.SelectedItem = ( _filterGraphController.VideoCompressor == null );
				for ( int c = 0; c < filters.VideoCompressors.Count; c++ )
				{
					f = filters.VideoCompressors[c];
					lstCompressor.Items.Add(f.Name);
					lstCompressor.SelectedItem =( _filterGraphController.VideoCompressor == f );
					
				}
			}
			catch {}

			// Load property pages
			try
			{
				lstProperties.Items.Clear();
				for ( int c = 0; c < _filterGraphController.PropertyPages.Count; c++ )
				{
					p = _filterGraphController.PropertyPages[c];
					lstProperties.Items.Add(p.Name + "...");
				}
			}
			catch { }

			setValues();
		}

		public virtual void setValues()
		{
//			Filter f;
			string str;

			str = String.Format(
				"Video Device Capabilities\n" +
				"--------------------------------\n\n" +
				"Input Size:\t\t{0} x {1}\n" +
				"\n" +
				"Min Frame Size:\t\t{2} x {3}\n" +
				"Max Frame Size:\t\t{4} x {5}\n" +
				"Frame Size Granularity X:\t{6}\n" +
				"Frame Size Granularity Y:\t{7}\n" +
				"\n" +
				"Min Frame Rate:\t\t{8:0.000} fps\n" +
				"Max Frame Rate:\t\t{9:0.000} fps\n", 
				_filterGraphController.VideoCaps.InputSize.Width, _filterGraphController.VideoCaps.InputSize.Height,
				_filterGraphController.VideoCaps.MinFrameSize.Width, _filterGraphController.VideoCaps.MinFrameSize.Height, 
				_filterGraphController.VideoCaps.MaxFrameSize.Width, _filterGraphController.VideoCaps.MaxFrameSize.Height, 
				_filterGraphController.VideoCaps.FrameSizeGranularityX, 
				_filterGraphController.VideoCaps.FrameSizeGranularityY,
				_filterGraphController.VideoCaps.MinFrameRate, 
				_filterGraphController.VideoCaps.MaxFrameRate );
			lblVideoCapatiblities.Text = str;
			
			// Load frame sizes
			try
			{
				SortedList s;
				cmbResolution.Items.Clear();
				Size frameSize = _filterGraphController.FrameSize;
				int Width = frameSize.Width;
				int Height =  frameSize.Height;
				s = _filterGraphController.getResolutionCaps();

				cmbResolution.Text =  Width + " x " + Height;

				if(NewResolution!= null)
					NewResolution("Auflsung: " + Width + " x " + Height);

				foreach(Size cursize in s.Values)
				{
					cmbResolution.Items.Add(cursize.Width + " x " + cursize.Height);
					cmbResolution.SelectedItem = ( frameSize == new Size( cursize.Width, cursize.Height ) );
				}
				
			}
			catch { }

			// Load frame rates
			try
			{
				cmbFramerate.Items.Clear();
				int frameRate = (int) (_filterGraphController.FrameRate * 1000);
				if(NewFrameRate != null)
					NewFrameRate("Frame Rate: " + frameRate/1000 + " fps");

				cmbFramerate.Items.Add("5 fps");
				cmbFramerate.SelectedItem = ( frameRate == 5000 );
				
				cmbFramerate.Items.Add("10 fps");
				cmbFramerate.SelectedItem = ( frameRate == 10000 );

				cmbFramerate.Items.Add("15 fps");
				cmbFramerate.SelectedItem = ( frameRate == 15000 );

				cmbFramerate.Items.Add("24 fps (Film)");
				cmbFramerate.SelectedItem = ( frameRate == 24000 );
				
				cmbFramerate.Items.Add("25 fps (PAL)");
				cmbFramerate.SelectedItem = ( frameRate == 25000 );

				cmbFramerate.Items.Add("29.997 fps (NTSC)");
				cmbFramerate.SelectedItem = ( frameRate == 29997 );

				cmbFramerate.Items.Add( "30 fps (~NTSC)");
				cmbFramerate.SelectedItem = ( frameRate == 30000 );

//				cmbFramerate.Items.Add( "59.994 fps (2xNTSC)");
//				cmbFramerate.SelectedItem = ( frameRate == 59994  );

				cmbFramerate.Text = frameRate/1000 + " fps";
			}
			catch {}

		}

		private void btnChoose_Click(object sender, System.EventArgs e)
		{
			this.txtFilename.Text = _Capture.chooseDirectory;
		}

		private void btnRecord_Click(object sender, System.EventArgs e)
		{

			try
			{
				if ( _filterGraphController == null )
					throw new ApplicationException( "Please select a video and/or audio device." );
				if ( !_filterGraphController.Cued )
					_filterGraphController.Filename = txtFilename.Text;
				_filterGraphController.Start();

				this.btnRecord.Enabled  = false;
				this.lstCompressor.Enabled = false;
				this.cmbResolution.Enabled = false;
				this.cmbFramerate.Enabled = false;
			
			}
			catch (Exception ex)
			{
				MessageBox.Show( ex.Message + "\n\n" + ex.ToString() );
			}

		}

		private void btnStop_Click(object sender, System.EventArgs e)
		{
			try
			{
				if ( _filterGraphController== null )
					throw new ApplicationException( "Please select a video and/or audio device." );
				_filterGraphController.Stop();
				this.btnRecord.Enabled  = true;
				this.lstCompressor.Enabled = true;
				this.cmbResolution.Enabled = true;
				this.cmbFramerate.Enabled = true;
			}
			catch (Exception ex)
			{
				MessageBox.Show( ex.Message + "\n\n" + ex.ToString() );
			}
		}

		private void lstCompressor_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			PropertyPage p;
			try
			{
				// Change the video compressor
				// We subtract 1 from m.Index beacuse the first item is (None)
				ListBox m = sender as ListBox;
				_filterGraphController.VideoCompressor = ( m.SelectedIndex >0 ? filters.VideoCompressors[m.SelectedIndex-1] : null );
				
			}
			catch (Exception ex)
			{ 
				MessageBox.Show( "Video compressor not supported.\n\n" + ex.Message + "\n\n" + ex.ToString() );
			}
			// Load property pages
			try
			{
				lstProperties.Items.Clear();
				for ( int c = 0; c < _filterGraphController.PropertyPages.Count; c++ )
				{
					p = _filterGraphController.PropertyPages[c];
					lstProperties.Items.Add(p.Name + "...");
				}
			}
			catch { }
		}

		private void cmbResolution_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			string str;
		
			str = String.Format(
				"Video Device Capabilities\n" +
				"--------------------------------\n\n" +
				"Input Size:\t\t{0} x {1}\n" +
				"\n" +
				"Min Frame Size:\t\t{2} x {3}\n" +
				"Max Frame Size:\t\t{4} x {5}\n" +
				"Frame Size Granularity X:\t{6}\n" +
				"Frame Size Granularity Y:\t{7}\n" +
				"\n" +
				"Min Frame Rate:\t\t{8:0.000} fps\n" +
				"Max Frame Rate:\t\t{9:0.000} fps\n", 
				_filterGraphController.VideoCaps.InputSize.Width, _filterGraphController.VideoCaps.InputSize.Height,
				_filterGraphController.VideoCaps.MinFrameSize.Width, _filterGraphController.VideoCaps.MinFrameSize.Height, 
				_filterGraphController.VideoCaps.MaxFrameSize.Width, _filterGraphController.VideoCaps.MaxFrameSize.Height, 
				_filterGraphController.VideoCaps.FrameSizeGranularityX, 
				_filterGraphController.VideoCaps.FrameSizeGranularityY,
				_filterGraphController.VideoCaps.MinFrameRate, 
				_filterGraphController.VideoCaps.MaxFrameRate );
			lblVideoCapatiblities.Text = str;

			try
			{
				// Update the frame size
				ComboBox m = sender as ComboBox;
				string[] s = m.Text.Split( 'x' );
				Size size = new Size( int.Parse( s[0] ), int.Parse( s[1] ) );
				_filterGraphController.setResolution(size);

				Size frameSize = _filterGraphController.FrameSize;
				if(NewResolution!= null)
					NewResolution("Auflsung: " + frameSize.Width + " x " + frameSize.Height);
				
			}
			catch (Exception ex)
			{ 
				MessageBox.Show( "Frame size not supported.\n\n" + ex.Message + "\n\n" + ex.ToString() );
			}
		
		}

		private void cmbFramerate_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
			try
			{

				ComboBox m = sender as ComboBox;
				string[] s = m.Text.Split( ' ' );
				_filterGraphController.setFramerate(double.Parse( s[0] ));

				int frameRate = (int) (_filterGraphController.FrameRate);
				if(NewFrameRate != null)
					NewFrameRate("Frame Rate: " + frameRate + " fps");

			}
			catch (Exception ex)
			{ 
				MessageBox.Show( "Frame rate not supported.\n\n" + ex.Message + "\n\n" + ex.ToString() );
			}
		}

		private void lstProperties_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			try
			{
				ListBox m = sender as ListBox;
				_filterGraphController.PropertyPages[m.SelectedIndex].Show( this );
			}
			catch (Exception ex)
			{ 
				MessageBox.Show( "Unable display property page. Please submit a bug report.\n\n" + ex.Message + "\n\n" + ex.ToString() );
			}
		}

		public Control PreviewWindow
		{
			get
			{
				return this.capturePanel;
			}
		}

	}
}
