using System;
using System.Collections;
using MT.Tracker.DataStructures;
using tsai;

namespace MTServer
{
	/// <summary>
	/// Zusammenfassung fr clsCamera.
	/// </summary>
	public class clsCamera:clsCameraDraw
	{
		protected string			_name;
		protected string			_conID;
		protected FeaturePointData	_fpdata;
		protected clsClient			_client;
		protected int				_curFrameID;

		
		public clsCamera(string name, string conID, clsCameraDraw CameraDraw, FeaturePointData fpdata, clsClient client, int curFrameID):base(CameraDraw)
		{
			_name = name;
			_conID = conID;
			_fpdata = fpdata;
			_client = client;
			_curFrameID = curFrameID;
		}

		/// <summary>
		/// Gets Name
		/// </summary>
		public string Name
		{	get { return _name; }	 }

		/// <summary>
		/// Gets the Connection ID
		/// </summary>
		public string ConID
		{	get { return _conID; }	 }
		
		/// <summary>
		/// Gets the Client
		/// </summary>
		public clsClient Client
		{	get { return _client; }	 }

		/// <summary>
		/// Gets the FPData
		/// </summary>
		public FeaturePointData FPData
		{	get { return _fpdata; }	 }

		/// <summary>
		/// Gets the current FrameID
		/// </summary>
		public int CurFrameID
		{	
			get { return _curFrameID; }	
			set 
			{
				_curFrameID = value;
			}
		
		}
	}
}
