using System;
using OpenGL;
using tsai;
using MT.Tracker.DataStructures;

namespace MTServer
{
	/// <summary>
	/// Zusammenfassung fr clsCamera.
	/// </summary>
	public class clsCameraDraw : tsai_converter
	{
		public clsCameraDraw(tsai_converter tsai) : base (tsai)
		{
			
		}

		public void Paint(string name)
		{
			//Logitech Webcam
			
			double xc = new double();
			double yc = new double();
			double zc = new double();
			double xw = new double();
			double yw = new double();
			double zw = new double();

			

			// Sichtpyramide
			
			base.get_camera_position(ref xw, ref yw, ref zw);
			vector3f campos = new vector3f((float)xw/1000, (float)yw/1000, (float)zw/1000);
		
			vector3f color = new vector3f();
		

			switch(name)
			{
				case "MT1":
					color.X = 0;
					color.Y = 0;
					color.Z = 1;
					break;
				case "MT2":
					color.X = 0;
					color.Y = 1;
					color.Z = 0;
					break;
				case "MT3":
					color.X = 0;
					color.Y = 1;
					color.Z = 1;
					break;
				case "MT4":
					color.X = 1;
					color.Y = 0;
					color.Z = 0;
					break;
				case "MT5":
					color.X = 1;
					color.Y = 0;
					color.Z = 1;
					break;
				case "MT6":
					color.X = 1;
					color.Y = 1;
					color.Z = 0;
					break;
				default:
					color.X = 0;
					color.Y = 0;
					color.Z = 0;
					break;
			}


			GL.glColor3f(color.X ,color.Y ,color.Z);

			base.image_coord_to_world_coord(0, 0, 0.01f, ref xw, ref yw);
			vector3f dir1 = new vector3f((float)xw/1000, (float)yw/1000, 0.01f);
					
			base.image_coord_to_world_coord(639, 0, 0.01f, ref xw, ref yw);
			vector3f dir2 = new vector3f((float)xw/1000, (float)yw/1000, 0.01f);

			base.image_coord_to_world_coord(0, 479, 0.01f, ref xw, ref yw);
			vector3f dir3 = new vector3f((float)xw/1000, (float)yw/1000, 0.01f);

			base.image_coord_to_world_coord(639, 479, 0.01f, ref xw, ref yw);
			vector3f dir4 = new vector3f((float)xw/1000, (float)yw/1000, 0.01f);

			base.image_coord_to_world_coord(320, 479, 0.01f, ref xw, ref yw);
			vector3f dir5 = new vector3f((float)xw/1000, (float)yw/1000, 0.01f);
		
					
//			WGL.drawLine(campos, dir1);
//			WGL.drawLine(campos, dir2);
//			WGL.drawLine(campos, dir3);
//			WGL.drawLine(campos, dir4);
//
//			WGL.drawLine(dir1, dir2);
//			WGL.drawLine(dir2, dir4);
//			WGL.drawLine(dir3, dir1);
//			WGL.drawLine(dir4, dir5);
//			WGL.drawLine(dir5, dir3);


			vector3f vec_a = new vector3f();
			vector3f vec_b = new vector3f();
			for (int i=0; i<620; i+=20)
			{
				base.image_coord_to_world_coord(i, 479, 0.01f, ref xw, ref yw);
				vec_a.X = (float)xw/1000;
				vec_a.Y = (float)yw/1000;
				vec_a.Z = 0.01f;
				base.image_coord_to_world_coord(i+20, 479, 0.01f, ref xw, ref yw);
				vec_b.X = (float)xw/1000;
				vec_b.Y = (float)yw/1000;
				vec_b.Z = 0.01f;
				WGL.drawLine(vec_a, vec_b);
			}
		
			// Webcam
			GL.glColor3f(0,0,0);

			GL.glTranslatef(campos.X, campos.Y, campos.Z);
			GL.glRotatef((float)(-base._cc.Rx/Math.PI*180),1,0,0);
			GL.glRotatef((float)(-base._cc.Ry/Math.PI*180),0,1,0);
			GL.glRotatef((float)(-base._cc.Rz/Math.PI*180),0,0,1);

			GL.glRotatef(90,0,0,1);
			//WGL.drawSphere(0.1f, 16, 16, new vector3f(0.4f,0.4f,0.4f));
			WGL.drawSphere(0.1f, 16, 16, new vector3f(color.X ,color.Y ,color.Z));
			WGL.drawCylinder(0.03f, new vector3f(0,0,0), new vector3f(0.15f,0,0),36,new vector3f(0,0,0));
			WGL.fillCircleYZ(new vector3f(0.15f,0,0),0.1f,36);
			GL.glRotatef(-90,0,0,1);
			GL.glRotatef(-90,0,1,0);
			WGL.drawCylinder(0.03f, new vector3f(0,0,0), new vector3f(0.12f,0,0),36,new vector3f(0,0,0));
			GL.glRotatef(90,0,1,0);

			GL.glRotatef((float)(base._cc.Rz/Math.PI*180),0,0,1);
			GL.glRotatef((float)(base._cc.Ry/Math.PI*180),0,1,0);
			GL.glRotatef((float)(base._cc.Rx/Math.PI*180),1,0,0);					
			GL.glTranslatef(-campos.X, -campos.Y, -campos.Z);
		}
	}
}
