using System;
using MT.Network;
using System.Collections;

namespace MTServer
{

	/// <summary>
	/// Zusammenfassung fr clsClientCollector.
	/// </summary>
	public class clsClientCollector: Hashtable
	{
		//declare Event Delegates
		public delegate void NewClientConnectDelegate(string conID, clsClientStatus clientStatus);
		public delegate void ClientDisconnectDelegate(string conID);

		//declare Events
		public event NewClientConnectDelegate NewClient;
		public event ClientDisconnectDelegate ClientDisconnect;

		protected MT.Network.clsBroadcastServer		_Server;
		protected clsClientStatus					_clientStatus;

		public clsClientCollector()
		{
			
		}

		public void Initialize(MT.Network.clsBroadcastServer Server)
		{
			_Server = Server;
			_Server.NewConnection += new MT.Network.clsServer.NewConnectionDelegate(_Server_NewConnection);
			_Server.ClosedConnection += new MT.Network.clsServer.ClosedConnectionDelegate(_Server_ClosedConnection);
			
		}

		private void _Server_NewConnection(string conID)
		{
			//new ClientStatus Class will be created
			_clientStatus = new clsClientStatus(conID,_Server);

			//Add Client to base
			base.Add(conID, _ClientStatus);

			//Announce new connection by raising event
			if (NewClient!=null){NewClient(conID, _clientStatus);}
		}

		private void _Server_ClosedConnection(string conID)
		{
			//new ClientStatus Class will be created
			_clientStatus = new clsClientStatus(conID,_Server);

			base.Remove(conID);

			//Announce new connection by raising event
			if (ClientDisconnect!=null){ClientDisconnect(conID);}
		}
	}
}
