using System;
using MT.Tracker.DataStructures;
using MT.Network;
using MT.Synchronization;
using System.Collections;

namespace MTServer
{
	/// <summary>
	/// Zusammenfassung fr clsServerController.
	/// </summary>
	public class clsServerController: Synchronizer
	{
		private		MT.Network.clsBroadcastServer	_Server;
//		private		Hashtable						_Data;
		private		clsClientCollection				_clientCollection;
		private		clsAssociation					_Association;
		private		cls3DView						_3DView=null;
		private		clsClientSynchronizer			_clientSynchronizer;
		private		clsFPFrameArrayContainer		_FPFrameArrayContainer;


		public clsServerController()
		{
			//
			// TODO: Fgen Sie hier die Konstruktorlogik hinzu
			//
		}

		public void Initialize()
		{
			//Create and Start Server
			_Server = new MT.Network.clsBroadcastServer(2347,1000);

			//Create SynchronizerContainer for FPData
			_FPFrameArrayContainer = new clsFPFrameArrayContainer();
			
			_clientCollection = new clsClientCollection(base.m_WorkerThread);
			_clientCollection.Initialize(_Server);

			_clientSynchronizer = new clsClientSynchronizer(_clientCollection,_Server);
			_clientSynchronizer.Initialize(_FPFrameArrayContainer);

			_Association = new clsAssociation(_clientCollection);
			_Association.Initialize(_Association, _clientSynchronizer);

		}

		public clsClientCollection ClientCollection
		{
			get{return _clientCollection;}
		}

		public clsAssociation Association
		{
			get{return _Association;}
		}

		public cls3DView DView
		{
			get{return _3DView;}
		}
		public clsBroadcastServer Server
		{
			get { return _Server; }
		}



//		private void _Server_NewMessageObject(string conID, clsNet message)
//		{
//			clsNetFeaturePointFrame frame  = message as clsNetFeaturePointFrame;
//			if (frame !=null)
//			{
//				if (frame.Frame != null)
//					Console.WriteLine("Received Frame {0}",frame.Frame.fid);
//			}
//		}
		



	}
}
