using System;
using tsai;
using MT.Tracker.DataStructures;
using System.Collections;

namespace MTServer
{



	/// <summary>
	/// Zusammenfassung fr Class1.
	/// </summary>
	public class TUKController
	{
//		tsai_converter[]	_cameras;
//		vector3f[]			_cameracoords;

		clsCameras			_cameras;

		//Datenpool fuer die Videodaten - er wird von Grafs Tool fuer jedes Frame jeweils aufgefuellt
		//und danach wird durch Aufruf der Funktion Feed die Berechnung 
//		FeaturePointData[]	_Data;


		Hashtable			_bodypoints = new Hashtable();
		Hashtable[]			_trajectories;					// Stores all Trajectory,Bodypoint Relations per camera





//		public TUKController(tsai_converter[] cameras, vector3f[] cameracoords, FeaturePointData[] Data)
//		{
//			_cameras = cameras;
//			_cameracoords = cameracoords;
//			_Data = Data;
//			_trajectories = new Hashtable[_cameras.GetLength(0)];
//
//			for (int i = 0; i< _cameras.Count;i++)
//				_trajectories[i] = new Hashtable();
//
//		
//			//pseudo[] moo = new pseudo[3]{new pseudo(), null, new pseudo()}; 
//			//if (moo[1] == null){Console.WriteLine("moo");}
//		}


//		public TUKController(tsai_converter[] cameras, vector3f[] cameracoords)
//		{
//			_cameras = cameras;
//			_cameracoords = cameracoords;
//			_trajectories = new Hashtable[_cameras.GetLength(0)];
//
//			for (int i = 0; i< _cameras.Count;i++)
//			{
//				_trajectories[i] = new Hashtable();
//			}
//		}


		public TUKController(clsCameras cameras)
		{
			_cameras = cameras;
			_trajectories = new Hashtable[_cameras.Count];

			for (int i = 0; i< _cameras.Count;i++)
			{
				_trajectories[i] = new Hashtable();
			}
		}

		/// <summary>
		/// Adds the given Bodypoint to the internal Hashtable and stores its currently active TrajectoryID.
		/// </summary>
		/// <param name="name"></param>
		/// <param name="BP"></param>
		/// <param name="tid"></param>
		public void AddBodyPoint(string name, BodyPoint BP, FeaturePoint[] FPs)
		{
			int tid = -1;
			_bodypoints.Add(name,BP);

			//Add given Featurepoints for all Cameras
			for(int i = 0; i< _cameras.Count;i++)
			{	BP.Feed(0,i,FPs[i]);
				tid = BP.LastKnownPosition(i).tid;
				if (tid!=-1)
					_trajectories[i].Add(tid,BP);
			}
			
			//Calculate first 3D Position
			BP.calc(0);
			BP.commit(0);

			//_bodypoints.Add(name, new BodyPoint(name, color, _cameras, _cameracoords));		
		}


		public void TrackFrame(clsFPFrameArrayColor Frames)
		{
			//Foodanalogy
			//-----------
			//This procedure is shown as an analogy of eaters = Bodypoints
			//which are hungry and want to eat food = Featurepoints
			//Each Bodypoint wants to eat one Featurepoint from each Camera
			//as long as it didn't get fed with a Featurepoint from a certain 
			//camera it will be hungry.

			//For our Datamanagement, we create a Hungry-Hashtable for each Camera
			//in which we initally store all Bodypoints.
			//During the Algorithm we will start to remove the BP whenever they are
			//fed
			FeaturePoint P;
			BodyPoint BP;
			SortedList[] HungryBPs = new SortedList[_cameras.Count];
			SortedList[] Food = new SortedList[_cameras.Count];


			int curFrame=Frames.fid;

//			if (_Data[0].CountFrames()<3) { return; }
	
			//Prepare list of Food and table of Hungry Bodypoints
			for (int c=0;c<_cameras.Count;c++)
			{
				//Index is always one lower than the CountValue and the IPAN Tracker is 
				//an additional frame behind, the TUK Tracker has to run 
				//another frame later to take profit off all IPAN Tracks
				//therefore the curFrame for the TUK
				//Tracker is -3 the current framecount

				//Frame of every Featurepoint set must ALWAYS be equal to all others
//				if (c>0 && curFrame!=_Data[c].CountFrames()-3){throw new Exception("Kat.2 AAAARGH");}

				
//				curFrame = _Data[c].CountFrames()-3;

				//Assertion(curFrame must NEVER be equal or lower than 0)
				if (curFrame<=0){throw new Exception("Kat.1 AAAARGH");}

				HungryBPs[c] = new SortedList(_bodypoints);
//				Food[c] = new SortedList(Frame[c]);
				Food[c] = new SortedList((SortedList)Frames.GetByIndex(c));
				
			}

			//Assertion(curFrame must NEVER be equal or lower than 0)
			if (curFrame<=0){throw new Exception("Kat.3 AAAARGH");}

			//for (int c=0;c<_cameras.Count;c++)
			foreach(FeaturePointFrameColor Frame in Frames.Values)
			{
				int c = Frames.IndexOfValue(Frame);

				//First Feed the FPs which belong to 
				//known Trajectories
				for(int i = 0;i<Frame.Count;i++)
				{	
					P = Frame.P(i);
					
					if (_trajectories[c].Contains(P.tid))
					{
						BP = (BodyPoint)_trajectories[c][P.tid];
						BP.Feed(curFrame,c,P);
						HungryBPs[c].Remove(BP.name);
						Food[c].Remove(P.fid);
					}

				}

				//If only one hungry BP and one FP is left, feed it to that BP
				//This action might have to be checked for consistency
				if(HungryBPs[c].Count==1 && Food[c].Count ==1)
				{
					//Get last Bodypoint
					IEnumerator lastBP = HungryBPs[c].Values.GetEnumerator();
					lastBP.MoveNext();
					BP = (BodyPoint)lastBP.Current;

					//Get last Featurepoint
					IEnumerator lastFP = Food[c].Values.GetEnumerator();
					lastFP.MoveNext();
					P = (FeaturePoint)lastFP.Current;

					BP.Feed(curFrame,c,P);
					HungryBPs[c].Remove(BP.name);
					Food[c].Remove(P.fid);

					//Store new Trajectory in Trajectories list
					_trajectories[c].Add(BP.LastKnownPosition(c).tid,BP);

				}
			}

			//After all trajectory related FPs have been fed - calculate first temporary position
			//to allow assoziation of newly started trajectories and detection of errors
			foreach(DictionaryEntry DE in _bodypoints)
			{
				BP = (BodyPoint)DE.Value;
				BP.calc(curFrame);

				int cid = BP.getWorstCamera();
				if(cid!=-1)
				{
					//Remove Featurepoint of a camera which gave us bad intersections -> it is most propably wrong
					P = BP.Unfeed(curFrame,cid);
					_trajectories[cid].Remove(P.tid);
					Food[cid].Add(P.fid,P);
					HungryBPs[cid].Add(BP.name,BP);

					//Console.WriteLine("Removed bad FP with Trajectory {0} from Camera {1}.",P.tid, _cameras.GetByIndex(cid).Name);
				}

			}


			for (int c=0;c<_cameras.Count;c++)
			{
				if (HungryBPs[c].Count > 0 && Food[c].Count>0)
				{

					//Create Distance Array
					float[,] Distance = new float[HungryBPs[c].Count,Food[c].Count];
					int i;
					int j;
					FeaturePoint BP_FP;

					//Search the best Food for the hungry Bodypoints
					//which only require one more food
					for(i=0; i<HungryBPs[c].Count;i++)
					{
						BP = (BodyPoint)HungryBPs[c].GetByIndex(i);
						BP_FP = BP.get2DCoord(curFrame,c);

						//If the BP has been detected by at least 2 cameras, try to associate it with 
						//the unassociated FPs of the non-tracking camera
						if (BP_FP !=null)
						{	
							for(j=0;j<Food[c].Count;j++)
							{
								P = (FeaturePoint)Food[c].GetByIndex(j);
						
								//Calculate Squared Distance in Pixels
								Distance[i,j] = (float)(BP_FP.X-P.X)*(BP_FP.X-P.X)+(BP_FP.Y-P.Y)*(BP_FP.Y-P.Y);
							}
						}
						else 
						{
							for (j = 0;j<Food[c].Count;j++)
							{
								Distance[i,j]=1000000;
							}
						}


					}

					float minimum;
					int minI = -1;
					int minJ = -1;

					do
					{
						minimum = 1000000;

						for(i = 0;i<HungryBPs[c].Count;i++)
						{
							for(j = 0;j<Food[c].Count;j++)
							{
								if (Distance[i,j]<=minimum)
								{
									minimum =Distance[i,j];
									minI = i;
									minJ = j;
								}
							}
						}

						//If a valid minimum has been found,
						//check if the distance is lower than the required minimal distance
						//for continuing trajectories.
						//If this is the case, feed the FP to the BP
						if (minimum != 1000000)
						if (minimum < 40)
						{
							BP = (BodyPoint)HungryBPs[c].GetByIndex(minI);
							P = (FeaturePoint)Food[c].GetByIndex(minJ);
							
							//Deactivated, network code doesnt restore connection between featurepoints
							//Only assoziate brand new trajectories since we don't want crossing trajectories to connect
//							if(P.LinkType == eFPLinkType.Forward)
//							{
								BP.Feed(curFrame,c,P);
								HungryBPs[c].Remove(BP.name);
								Food[c].Remove(P.fid);

								//Store new Trajectory in Trajectories list
								_trajectories[c].Add(BP.LastKnownPosition(c).tid,BP);

								//Console.WriteLine("Frame {3}: connected new Trajectory {2} from Camera {0} to Bodypoint {1}",c+1,BP.name,P.tid,curFrame);
//							}
						}

						//Delete used points from the error Matrix
						//by setting the errorvalues to 1000000
						for(i = 0;i< HungryBPs[c].Count;i++)
							Distance[i,minJ] = 1000000;

						for(j = 0;j<Food[c].Count;j++)
							Distance[minI,j] = 1000000;


					}while (minimum!= 1000000);


				}
			}


			for (int c=0;c<_cameras.Count;c++)
			{
			}

			foreach(DictionaryEntry DE in _bodypoints)
			{
				BP = (BodyPoint)DE.Value;
//				if(BP.name == "Fuss_Rechts")
//				{
//					Console.WriteLine("iQuality von {0} betraegt {1}", BP.name,BP.intersectionQuality(curFrame));
//				}
			}



			//After all FPs have been fed - commit definite positions
			foreach(DictionaryEntry DE in _bodypoints)
			{
				BP = (BodyPoint)DE.Value;
				BP.commit(curFrame);
				
//				if(BP.name == "Fuss_Rechts")
//					Console.WriteLine("mQuality: {0}", BP.moveQuality(curFrame));

			}

		}

/*
 						//If a valid BP Position could not be precalced (the BP has only been seen
						//by 1 camera for some time) use the last known position to determine 
						//its distance
						if (BP_FP== null) { BP_FP = (BP.LastKnownPosition(c)); }
*/

		public void PaintFrame(int FrameID)
		{
			//int fid = _Data[0].CountFrames() - 3;

			BodyPoint BP;

			foreach(DictionaryEntry DE in _bodypoints)
			{
				BP = (BodyPoint)DE.Value;
				BP.paint(FrameID);
			}
		}

	}

	
}
