using System;
using MT.Tracker.DataStructures;
using tsai;
using System.Collections;
using OpenGL;


namespace MTServer
{
	/// <summary>
	/// Summary description for clsTUKMain.
	/// </summary>
	public class TUKMain
	{
//		private FeaturePointData[]	_A;
//		private FeaturePointData[]	_R;
//		private FeaturePointData[]	_G;
//		private FeaturePointData[]	_B;

		private TUKController		_TUK_R;
		private TUKController		_TUK_G;
		private TUKController		_TUK_B;

//		private tsai_converter[]	_cameras;
//		private vector3f[]			_cameracoords;

		private Hashtable			_bodypoints = new Hashtable();
		private Hashtable			_bodyconnectors = new Hashtable();

//		clsClientCollection	_ClientCollection=null;

		private clsCameras			_cameras;
		private frm3DView			_GL3DView;


		public delegate void NewTrackDelegate(int FrameID);
		public event NewTrackDelegate NewTrack;

		//		FrameLoader _Loader; 
		//		FrameSaver _Saver;




//		public TUKMain(tsai_converter[] cameras, vector3f[] cameracoords,
//							FeaturePointData[] A, 
//							FeaturePointData[] R, 
//							FeaturePointData[] G, 
//							FeaturePointData[] B)
//		{
//
//			_cameras = cameras;
//			_cameracoords = cameracoords;
//
//			_A = A;
//			_R = R;
//			_G = G;
//			_B = B;
//			//Initalize 3 Trackers each for one color
//			_TUK_R = new TUKController(cameras,cameracoords,_R);
//			_TUK_G = new TUKController(cameras,cameracoords,_G);
//			_TUK_B = new TUKController(cameras,cameracoords,_B);
//		
//		}


//		public TUKMain(tsai_converter[] cameras, vector3f[] cameracoords, clsClientCollection ClientCollection)
//		{
//			_cameras	  = cameras;
//			_cameracoords = cameracoords;
//			_ClientCollection = ClientCollection;
//			
//			//Initalize 3 Trackers each for one color
//			_TUK_R = new TUKController(cameras, cameracoords);
//			_TUK_G = new TUKController(cameras, cameracoords);
//			_TUK_B = new TUKController(cameras, cameracoords);
//		}


//		public TUKMain(clsClientCollection ClientCollection)
//		{
//			_ClientCollection	= ClientCollection;
//
//			vector3f[] cameracoords		= new vector3f[_ClientCollection.Count];
//			tsai_converter[] cameras	= new tsai_converter[_ClientCollection.Count];
//
//			double xc = new double();
//			double yc = new double();
//			double zc = new double();
//			int m=0;
//			foreach (clsClient Client in _ClientCollection.Values)
//			{
//
//				if (Client.FPData.FeaturePointFrames.Count!=0 && Client.Tsai!=null)
//				{
//					
//					tsai_converter tsai		= (tsai_converter)Client.Tsai;
//					tsai.get_camera_position(ref xc, ref yc, ref zc);
//					cameracoords[m] = new vector3f((float)xc, (float)yc, (float)zc);
//					cameras[m]		 = tsai;
//					m++;
//
//				}
//			}
//	
//			_cameracoords	= cameracoords;
//			_cameras		= cameras;
//
//	
//			//Initalize 3 Trackers each for one color
//			_TUK_R = new TUKController(_cameras, _cameracoords);
//			_TUK_G = new TUKController(_cameras, _cameracoords);
//			_TUK_B = new TUKController(_cameras, _cameracoords);
//		}


		public TUKMain(clsCameras cameras, frm3DView GL3DView)
		{
			_cameras = cameras;
			_GL3DView = GL3DView;
			//Initalize 3 Trackers each for one color
			_TUK_R = new TUKController(_cameras);
			_TUK_G = new TUKController(_cameras);
			_TUK_B = new TUKController(_cameras);
		}


		public void Reset()
		{
			//Initalize 3 Trackers each for one color
//			_TUK_R = new TUKController(_cameras, _cameracoords);
//			_TUK_G = new TUKController(_cameras, _cameracoords);
//			_TUK_B = new TUKController(_cameras, _cameracoords);

			_TUK_R = new TUKController(_cameras);
			_TUK_G = new TUKController(_cameras);
			_TUK_B = new TUKController(_cameras);
		}


		public void CreateBodyPoint(string name, eColorCode color, FeaturePoint[] FPs)
		{
			BodyPoint BP;

			switch (color)
			{
//				case eColorCode.R:
//					BP = new BodyPoint(name, color, _cameras, _cameracoords);
//					_TUK_R.AddBodyPoint(name,BP,FPs);
//					_bodypoints.Add(name,BP);
//					break;
//				case eColorCode.G:
//					BP = new BodyPoint(name, color, _cameras, _cameracoords);
//					_TUK_G.AddBodyPoint(name,BP,FPs);
//					_bodypoints.Add(name,BP);
//					break;
//				case eColorCode.B:
//					BP = new BodyPoint(name, color, _cameras, _cameracoords);
//					_TUK_B.AddBodyPoint(name,BP,FPs);
//					_bodypoints.Add(name,BP);
//					break;

				case eColorCode.R:
					BP = new BodyPoint(name, color, _cameras, _GL3DView);
					_TUK_R.AddBodyPoint(name,BP,FPs);
					_bodypoints.Add(name,BP);
					break;
				case eColorCode.G:
					BP = new BodyPoint(name, color, _cameras, _GL3DView);
					_TUK_G.AddBodyPoint(name,BP,FPs);
					_bodypoints.Add(name,BP);
					break;
				case eColorCode.B:
					BP = new BodyPoint(name, color, _cameras, _GL3DView);
					_TUK_B.AddBodyPoint(name,BP,FPs);
					_bodypoints.Add(name,BP);
					break;
			}
		}

		/// <summary>
		/// Creates a Body Connector Object that connects 2 existing Bodypoints when they are painted.
		/// </summary>
		/// <param name="name">Name of the BodyConnector (must be unique to all BodyConnectors and Bodypoints or an exception is thrown</param>
		/// <param name="LeftConnectedBP">Name of the left connected Bodypoint</param>
		/// <param name="RightconnectedBP">Name of the right connected BOdypoint</param>
		public void CreateBodyConnector(string name, string LeftConnectedBP, string RightConnectedBP, float elasticity)
		{	
			_bodyconnectors.Add(name, new BodyConnector(name,(BodyPoint)_bodypoints[LeftConnectedBP],(BodyPoint)_bodypoints[RightConnectedBP],elasticity));
		}
		public void CreateBodyConnector(string name, string LeftConnectedBP, string FirstRightConnectedBP, string SecondRightConnectedBP, float elasticity)
		{	
			_bodyconnectors.Add(name, new BodyConnector(name,(BodyPoint)_bodypoints[LeftConnectedBP],(BodyPoint)_bodypoints[FirstRightConnectedBP],(BodyPoint)_bodypoints[SecondRightConnectedBP],elasticity));
		}
		public void CreateBodyConnector(string name, string FirstLeftConnectedBP, string SecondLeftConnectedBP, string FirstRightConnectedBP, string SecondRightConnectedBP,float elasticity)
		{	
			_bodyconnectors.Add(name, new BodyConnector(name,(BodyPoint)_bodypoints[FirstLeftConnectedBP],(BodyPoint)_bodypoints[SecondLeftConnectedBP],(BodyPoint)_bodypoints[FirstRightConnectedBP],(BodyPoint)_bodypoints[SecondRightConnectedBP],elasticity));
		}
		/// <summary>
		/// Called by the parent, each time when a new Frame is available.
		/// </summary>
		public void TrackFrame(clsFPFrameArray Frame)
		{
			_TUK_R.TrackFrame(Frame.F_Red);
			_TUK_G.TrackFrame(Frame.F_Green);
			_TUK_B.TrackFrame(Frame.F_Blue);


//			BodyPoint BP;
//			int curFrame = _A[0].CountFrames()-3;
//			foreach(DictionaryEntry DE in _bodypoints)
//			{
//				BP = (BodyPoint)DE.Value;
//
//				if(BP.name == "Huefte_Rechts")
//					BP.quality(curFrame);
////					Console.WriteLine("Die Connector Qualitaet von {0} betraegt {1}", BP.name,BP.quality(curFrame));
//			}

			if (NewTrack!=null)
				NewTrack(Frame.fid);

		}

		public void PaintFrame(int FrameID, bool Leinwand)
		{
			// Weltkoordinaten Offset
			float dx = -2.4f;
			float dy = -1.2f;
			float dz =  0.0f;
			
			//Draw Floor
			GL.glColor3f(0.5f,0.5f,0.5f);
			for (int x=0; x<7; x++)
			{
				for (int y=0; y<4; y++)
				{
					WGL.drawRectangle(	new vector3f( (float)(x*1.2+1.18)+dx, (float)(y*1.2+1.18)+dy, 0.0f+dz),
										new vector3f( (float)(x*1.2+1.18)+dx, (float)(y*1.2+0.02)+dy, 0.0f+dz),
										new vector3f( (float)(x*1.2+0.02)+dx, (float)(y*1.2+1.18)+dy, 0.0f+dz),
										new vector3f( (float)(x*1.2+0.02)+dx, (float)(y*1.2+0.02)+dy, 0.0f+dz));
				}
			}
			WGL.drawRectangle(	new vector3f(10.2f+dx, -0.02f+dy, 0.0f+dz),
								new vector3f(10.2f+dx, -2.0f+dy,  0.0f+dz),
								new vector3f(-2.0f+dx, -0.02f+dy, 0.0f+dz),
								new vector3f(-2.0f+dx, -2.0f+dy,  0.0f+dz));

			WGL.drawRectangle(	new vector3f(10.2f+dx, 5.6f+dy,  0.0f+dz),
								new vector3f(10.2f+dx, 3.62f+dy, 0.0f+dz),
								new vector3f(-2.0f+dx, 5.6f+dy,  0.0f+dz),
								new vector3f(-2.0f+dx, 3.62f+dy, 0.0f+dz));

			WGL.drawRectangle(	new vector3f(10.2f+dx, 3.62f+dy,  0.0f+dz),
								new vector3f(10.2f+dx, -0.02f+dy, 0.0f+dz),
								new vector3f(7.22f+dx, 3.62f+dy,  0.0f+dz),
								new vector3f(7.22f+dx, -0.02f+dy, 0.0f+dz));

			WGL.drawRectangle(	new vector3f(-0.02f+dx, 3.62f+dy,  0.0f+dz),
								new vector3f(-0.02f+dx, -0.02f+dy, 0.0f+dz),
								new vector3f(-2.0f+dx,  3.62f+dy,  0.0f+dz),
								new vector3f(-2.0f+dx,  -0.02f+dy, 0.0f+dz));


			if (Leinwand)
			{

				foreach (clsCamera camera in _cameras.Values)
				{
					camera.Paint(camera.Name);
				}
				// 2D-Bilder der einzelnen Kameras (Featurepoints)
//				vector3f center = new vector3f(3.6f,  1.8f,  1.0f);
//				for (int i=0; i<_cameras.Length; i++)
//				{

					

					// Sichtpyramide
//					double xw = new double();
//					double yw = new double();
//					double zw = new double();
//
//					_cameras[i].get_camera_position(ref xw, ref yw, ref zw);
//					vector3f campos = new vector3f((float)xw/1000, (float)yw/1000, (float)zw/1000);
//
//						
//					
//					GL.glColor3f(0,1,0);
//					_cameras[i].image_coord_to_world_coord(0, 0, 0.01f, ref xw, ref yw);
//					vector3f dir1 = new vector3f((float)xw/1000, (float)yw/1000, 0.01f);
//					
//					_cameras[i].image_coord_to_world_coord(639, 0, 0.01f, ref xw, ref yw);
//					vector3f dir2 = new vector3f((float)xw/1000, (float)yw/1000, 0.01f);
//
//					_cameras[i].image_coord_to_world_coord(0, 479, 0.01f, ref xw, ref yw);
//					vector3f dir3 = new vector3f((float)xw/1000, (float)yw/1000, 0.01f);
//
//					_cameras[i].image_coord_to_world_coord(639, 479, 0.01f, ref xw, ref yw);
//					vector3f dir4 = new vector3f((float)xw/1000, (float)yw/1000, 0.01f);
//		
//					
//					WGL.drawLine(campos, dir1);
//					WGL.drawLine(campos, dir2);
//					WGL.drawLine(campos, dir3);
//					WGL.drawLine(campos, dir4);
//
//					WGL.drawLine(dir1, dir2);
//					WGL.drawLine(dir2, dir4);
//					WGL.drawLine(dir4, dir3);
//					WGL.drawLine(dir3, dir1);
//
//
//					// Webcam
//					GL.glColor3f(0,0,0);
//
//					GL.glTranslatef(campos.X, campos.Y, campos.Z);
//					GL.glRotatef((float)(-_cameras[i]._cc.Rx/Math.PI*180),1,0,0);
//					GL.glRotatef((float)(-_cameras[i]._cc.Ry/Math.PI*180),0,1,0);
//					GL.glRotatef((float)(-_cameras[i]._cc.Rz/Math.PI*180),0,0,1);
//					
//					GL.glRotatef(90,0,0,1);
//					WGL.drawSphere(0.1f, 16, 16, new vector3f(0.4f,0.4f,0.4f));
//					WGL.drawCylinder(0.03f, new vector3f(0,0,0), new vector3f(0.15f,0,0),36,new vector3f(0,0,0));
//					WGL.fillCircleYZ(new vector3f(0.15f,0,0),0.1f,36);
//					GL.glRotatef(-90,0,0,1);
//					GL.glRotatef(-90,0,1,0);
//					WGL.drawCylinder(0.03f, new vector3f(0,0,0), new vector3f(0.12f,0,0),36,new vector3f(0,0,0));
//					GL.glRotatef(90,0,1,0);
//
//					GL.glRotatef((float)(_cameras[i]._cc.Rz/Math.PI*180),0,0,1);
//					GL.glRotatef((float)(_cameras[i]._cc.Ry/Math.PI*180),0,1,0);
//					GL.glRotatef((float)(_cameras[i]._cc.Rx/Math.PI*180),1,0,0);					
//					GL.glTranslatef(-campos.X, -campos.Y, -campos.Z);



					// Leinwand
//					GL.glTranslatef(_cameracoords[i].X/1000 + 2*(center.X-_cameracoords[i].X/1000),
//						_cameracoords[i].Y/1000 + 2*(center.Y-_cameracoords[i].Y/1000),
//						_cameracoords[i].Z/1000 + 2*(center.Z-_cameracoords[i].Z/1000));
//					GL.glRotatef(alpha,0,0,1);
//
//					//Rahmen der Leinwand
//					WGL.drawRectangle(	new vector3f(0,  0.02f, -0.48f),
//						new vector3f(0,  0.02f, -0.65f),
//						new vector3f(0, -0.02f, -0.48f),
//						new vector3f(0, -0.02f, -0.65f));
//
//					WGL.drawRectangle(	new vector3f(0,  0.02f, -0.65f),
//						new vector3f(0,  0.32f, -0.82f),
//						new vector3f(0, -0.02f, -0.65f),
//						new vector3f(0,  0.36f, -0.82f));
//
//					WGL.drawRectangle(	new vector3f(0,  0.02f, -0.65f),
//						new vector3f(0, -0.36f, -0.82f),
//						new vector3f(0, -0.02f, -0.65f),
//						new vector3f(0, -0.32f,	-0.82f));
//
//					WGL.drawRectangle(	new vector3f(0,  0.64f, -0.48f),
//						new vector3f(0, -0.64f, -0.48f),
//						new vector3f(0,  0.64f,  0.48f),
//						new vector3f(0, -0.64f,  0.48f));
//					// Leinwand
//					GL.glColor3f(1,1,1);
//					WGL.drawRectangle(	new vector3f(0.001f,  0.60f, -0.44f),
//						new vector3f(0.001f, -0.60f, -0.44f),
//						new vector3f(0.001f,  0.60f,  0.44f),
//						new vector3f(0.001f, -0.60f,  0.44f));
//
//				
////					for (int j=0; j<_A[i].Count(FrameID); j++ )
////					{
////						GL.glTranslatef(0.002f, (320-(640-_A[i].P(FrameID, j).X))/500 , -(_A[i].P(FrameID, j).Y/500 - 0.48f));
////						if(_A[i].P(FrameID, j).Color == eColorCode.R) GL.glColor3f(1,0,0);
////						if(_A[i].P(FrameID, j).Color == eColorCode.G) GL.glColor3f(0,1,0);
////						if(_A[i].P(FrameID, j).Color == eColorCode.B) GL.glColor3f(0,0,1);
////						WGL.fillCircleYZ(new vector3f(0,0,0), 0.03f, 12);
////						//WGL.drawSphere(0.03f, 12, 12);
////						GL.glTranslatef(-0.002f, -(320-(640-_A[i].P(FrameID, j).X))/500, (_A[i].P(FrameID, j).Y/500) - 0.48f);
////					}
//
//					GL.glRotatef(-alpha,0,0,1);
//					GL.glTranslatef(-(_cameracoords[i].X/1000 + 2*(center.X-_cameracoords[i].X/1000)),
//						-(_cameracoords[i].Y/1000 + 2*(center.Y-_cameracoords[i].Y/1000)),
//						-(_cameracoords[i].Z/1000 + 2*(center.Z-_cameracoords[i].Z/1000)));
				
//				}

				

//				foreach (clsClient Client in _ClientCollection.Values)
//				{
//					FeaturePointFrame FPframe = (FeaturePointFrame) Client.FPData.FeaturePointFrames.GetByIndex(FrameID);
//					foreach (FeaturePoint p in FPframe.Values)
//					{
//						GL.glTranslatef(0.002f, (320-(640-p.X))/500 , -(p.Y/500 - 0.48f));
//					
//						if(FPframe.Color == eColorCode.R) GL.glColor3f(1,0,0);
//						if(FPframe.Color == eColorCode.G) GL.glColor3f(0,1,0);
//						if(FPframe.Color == eColorCode.B) GL.glColor3f(0,0,1);
//						WGL.fillCircleYZ(new vector3f(0,0,0), 0.03f, 12);
//
//					
//						GL.glTranslatef(-0.002f, -(320-(640-p.X))/500, (p.Y/500) - 0.48f);
//					}
//				}
			}
			GL.glColor3f(1,0,0);
			_TUK_R.PaintFrame(FrameID);
			GL.glColor3f(0,1,0);
			_TUK_G.PaintFrame(FrameID);
			GL.glColor3f(0,0,1);
			_TUK_B.PaintFrame(FrameID);

//			BodyPoint BP;
//			foreach(DictionaryEntry DE in _bodypoints)
//			{	
//				BP = (BodyPoint)DE.Value;
//				BP.paint(FrameID);
//			}
			
			BodyConnector BC;
			foreach(DictionaryEntry DE in _bodyconnectors)
			{	
				BC = (BodyConnector)DE.Value;
				BC.Paint(FrameID);
			}
		}


	}
}
