using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using OpenGL;
using MT.Tracker.DataStructures;

namespace MTServer
{
	/// <summary>
	/// Zusammenfassung fr usc3DView.
	/// </summary>
	public class usc3DView : System.Windows.Forms.UserControl
	{

		private	cls3DView				_3DView;
		//OpenGL
		public static uint				m_uint_HWND = 0;
		public static uint				m_uint_DC   = 0;
		public static uint				m_uint_RC   = 0;
		public static uint				m_uint_AttemptedInitialization = 0;

		//OpenGL Functions
//		private bool	_OpenGLInitialized = false;
//		private uint	_OpenGLWindowHWND;
//		private uint	_OpenGLDC;
//		private uint	_OpenGLRC;

//		int			_maxGLFrame= -1;		//Stores Maximal viewable Tracked frame
		int			_curGLFrame = -1;		//Stores Number of the currently showed frame in OpenGL Panel

		private System.Windows.Forms.Panel pnlOpenGL;
		private System.Windows.Forms.TrackBar tbrFrame;
		private System.Windows.Forms.Timer timerOpenGL;
		private System.ComponentModel.IContainer components;

		public usc3DView()
		{
			// Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
			InitializeComponent();

			// TODO: Initialisierungen nach dem Aufruf von InitializeComponent hinzufgen

		}

		/// <summary> 
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Komponenten-Designer generierter Code
		/// <summary> 
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.pnlOpenGL = new System.Windows.Forms.Panel();
			this.tbrFrame = new System.Windows.Forms.TrackBar();
			this.timerOpenGL = new System.Windows.Forms.Timer(this.components);
			((System.ComponentModel.ISupportInitialize)(this.tbrFrame)).BeginInit();
			this.SuspendLayout();
			// 
			// pnlOpenGL
			// 
			this.pnlOpenGL.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.pnlOpenGL.BackColor = System.Drawing.Color.Black;
			this.pnlOpenGL.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlOpenGL.Cursor = System.Windows.Forms.Cursors.Cross;
			this.pnlOpenGL.Location = new System.Drawing.Point(8, 6);
			this.pnlOpenGL.Name = "pnlOpenGL";
			this.pnlOpenGL.Size = new System.Drawing.Size(872, 586);
			this.pnlOpenGL.TabIndex = 31;
			this.pnlOpenGL.MouseUp += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseUp);
			this.pnlOpenGL.Paint += new System.Windows.Forms.PaintEventHandler(this.pnlOpenGL_Paint);
			this.pnlOpenGL.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseMove);
			this.pnlOpenGL.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseDown);
			this.pnlOpenGL.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseWheel);
			// 
			// tbrFrame
			// 
			this.tbrFrame.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.tbrFrame.AutoSize = false;
			this.tbrFrame.Location = new System.Drawing.Point(0, 592);
			this.tbrFrame.Maximum = 0;
			this.tbrFrame.Name = "tbrFrame";
			this.tbrFrame.Size = new System.Drawing.Size(888, 20);
			this.tbrFrame.TabIndex = 33;
			this.tbrFrame.TickStyle = System.Windows.Forms.TickStyle.None;
			this.tbrFrame.Scroll += new System.EventHandler(this.tbrFrame_Scroll);
			// 
			// timerOpenGL
			// 
			this.timerOpenGL.Tick += new System.EventHandler(this.timerOpenGL_Tick);
			// 
			// usc3DView
			// 
			this.Controls.Add(this.tbrFrame);
			this.Controls.Add(this.pnlOpenGL);
			this.Name = "usc3DView";
			this.Size = new System.Drawing.Size(944, 632);
			//this.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.pnlOpenGL_MouseWheel);
			((System.ComponentModel.ISupportInitialize)(this.tbrFrame)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion
	
		public void Initialize(cls3DView GLView, TUKMain tukMain)
		{
			_3DView = GLView;
			_3DView = new cls3DView(this.pnlOpenGL, tukMain);
			_3DView.Initialize();

			timerOpenGL.Enabled = true;
		}

		private void timerOpenGL_Tick(object sender, System.EventArgs e)
		{
			refreshGL();
		}

		private void tbrFrame_Scroll(object sender, System.EventArgs e)
		{
			_curGLFrame = tbrFrame.Value;
			refreshGL();
		}

		private void refreshGL()
		{
			_3DView.refreshGL();
		}

		private void pnlOpenGL_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			refreshGL();
		}

		private void pnlOpenGL_MouseMove(object sender, System.Windows.Forms.MouseEventArgs  e)
		{	
			_3DView.pnlOpenGL_MouseMove(e);
		}

		private void pnlOpenGL_MouseDown(object sender, System.Windows.Forms.MouseEventArgs  e)
		{
			_3DView.pnlOpenGL_MouseDown(e);
		}

		private void pnlOpenGL_MouseUp(object sender, System.Windows.Forms.MouseEventArgs  e)
		{
			_3DView.pnlOpenGL_MouseUp(e);
		}

		public void pnlOpenGL_MouseWheel(object sender, System.Windows.Forms.MouseEventArgs  e)
		{
			_3DView.pnlOpenGL_MouseWheel(e);
		}



		

	}
}
