using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using MT.Tracker.DataStructures;
using MT.Network;
    

namespace MTServer
{
	/// <summary>
	/// Zusammenfassung fr uscAssociation.
	/// </summary>
	public class uscAssociation : System.Windows.Forms.UserControl
	{

		string	_client;
		int _signal=0;

		private clsAssociation _Association;
		private clsClientCollection _ClientCollection;
		private clsBroadcastServer _BroadcastServer;

		private System.Windows.Forms.PictureBox pbox_Bitmap;
		private System.Windows.Forms.NumericUpDown nUD_Size;
		private System.Windows.Forms.Label lbl_Size;
		private System.Windows.Forms.Button btn_Associate;
		private System.Windows.Forms.ListBox lbox_Client;
		/// <summary> 
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public uscAssociation()
		{
			// Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
			InitializeComponent();

			// TODO: Initialisierungen nach dem Aufruf von InitializeComponent hinzufgen

		}

		public void Initialize(clsAssociation Association, clsClientCollection ClientCollection, clsBroadcastServer BroadcastServer)
		{
			_Association = Association;
			_Association.Resize3Dmodel();
			_ClientCollection = ClientCollection;
			_BroadcastServer = BroadcastServer;

			_ClientCollection.NewClient +=new MTServer.clsClientCollection.NewClientConnectDelegate(_ClientCollection_NewClient);
			_ClientCollection.ClientDisconnect +=new MTServer.clsClientCollection.ClientDisconnectDelegate(_ClientCollection_ClientDisconnect);

		}

		private void _ClientCollection_ClientDisconnect(string conID)
		{
			Actualize_lbox_Client();
		}
		private void _ClientCollection_NewClient(string conID, clsClient client)
		{
			Actualize_lbox_Client();
		}


		private void Actualize_lbox_Client()
		{
			lbox_Client.Items.Clear();

			foreach (clsClient Client in _ClientCollection.Values)
			{
				lbox_Client.Items.Add(Client.Host);
			}
		}

		/// <summary> 
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Komponenten-Designer generierter Code
		/// <summary> 
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.pbox_Bitmap = new System.Windows.Forms.PictureBox();
			this.nUD_Size = new System.Windows.Forms.NumericUpDown();
			this.lbl_Size = new System.Windows.Forms.Label();
			this.btn_Associate = new System.Windows.Forms.Button();
			this.lbox_Client = new System.Windows.Forms.ListBox();
			((System.ComponentModel.ISupportInitialize)(this.nUD_Size)).BeginInit();
			this.SuspendLayout();
			// 
			// pbox_Bitmap
			// 
			this.pbox_Bitmap.BackColor = System.Drawing.Color.White;
			this.pbox_Bitmap.Location = new System.Drawing.Point(16, 16);
			this.pbox_Bitmap.Name = "pbox_Bitmap";
			this.pbox_Bitmap.Size = new System.Drawing.Size(640, 480);
			this.pbox_Bitmap.TabIndex = 0;
			this.pbox_Bitmap.TabStop = false;
			this.pbox_Bitmap.Paint += new System.Windows.Forms.PaintEventHandler(this.pbox_Bitmap_Paint);
			// 
			// nUD_Size
			// 
			this.nUD_Size.Location = new System.Drawing.Point(712, 144);
			this.nUD_Size.Maximum = new System.Decimal(new int[] {
																	 200,
																	 0,
																	 0,
																	 0});
			this.nUD_Size.Minimum = new System.Decimal(new int[] {
																	 150,
																	 0,
																	 0,
																	 0});
			this.nUD_Size.Name = "nUD_Size";
			this.nUD_Size.Size = new System.Drawing.Size(48, 20);
			this.nUD_Size.TabIndex = 1;
			this.nUD_Size.Value = new System.Decimal(new int[] {
																   165,
																   0,
																   0,
																   0});
			this.nUD_Size.ValueChanged += new System.EventHandler(this.nUD_Size_ValueChanged);
			// 
			// lbl_Size
			// 
			this.lbl_Size.Location = new System.Drawing.Point(664, 144);
			this.lbl_Size.Name = "lbl_Size";
			this.lbl_Size.Size = new System.Drawing.Size(48, 16);
			this.lbl_Size.TabIndex = 2;
			this.lbl_Size.Text = "Grsse:";
			// 
			// btn_Associate
			// 
			this.btn_Associate.Location = new System.Drawing.Point(664, 184);
			this.btn_Associate.Name = "btn_Associate";
			this.btn_Associate.Size = new System.Drawing.Size(128, 23);
			this.btn_Associate.TabIndex = 3;
			this.btn_Associate.Text = "Assoziieren";
			this.btn_Associate.Click += new System.EventHandler(this.btn_Associate_Click);
			// 
			// lbox_Client
			// 
			this.lbox_Client.Location = new System.Drawing.Point(664, 16);
			this.lbox_Client.Name = "lbox_Client";
			this.lbox_Client.ScrollAlwaysVisible = true;
			this.lbox_Client.Size = new System.Drawing.Size(128, 95);
			this.lbox_Client.TabIndex = 4;
			this.lbox_Client.SelectedIndexChanged += new System.EventHandler(this.lbox_Client_SelectedIndexChanged);
			// 
			// uscAssociation
			// 
			this.Controls.Add(this.lbox_Client);
			this.Controls.Add(this.btn_Associate);
			this.Controls.Add(this.lbl_Size);
			this.Controls.Add(this.nUD_Size);
			this.Controls.Add(this.pbox_Bitmap);
			this.Name = "uscAssociation";
			this.Size = new System.Drawing.Size(800, 512);
			((System.ComponentModel.ISupportInitialize)(this.nUD_Size)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion


		private void pbox_Bitmap_Paint(object sender, PaintEventArgs e) 
		{
			try
			{
				e.Graphics.SmoothingMode = SmoothingMode.AntiAlias;				
				Pen mypenRed		= new Pen(Color.Red,2);
				Pen mypenBlue		= new Pen(Color.Blue,2);
				Pen mypenGreen		= new Pen(Color.Green,2);
				Pen mypenBlack		= new Pen(Color.Black,2);
				Pen mypenPink		= new Pen(Color.Pink,2);
				Brush mybrushRed	= new System.Drawing.SolidBrush(Color.Red);
				Brush mybrushBlue	= new System.Drawing.SolidBrush(Color.Blue);
				Brush mybrushGreen	= new System.Drawing.SolidBrush(Color.Green);
				
				// 3D-Modell
				if( _Association.Model2D[0,0]!=0)
				{
					e.Graphics.DrawLine(mypenBlack, (float)_Association.Model2D[0,0],  (float)_Association.Model2D[0,1],  (float)_Association.Model2D[4,0],  (float)_Association.Model2D[4,1]);	//linker Unterarm 
					e.Graphics.DrawLine(mypenBlack, (float)_Association.Model2D[4,0],  (float)_Association.Model2D[4,1],  (float)_Association.Model2D[9,0],  (float)_Association.Model2D[9,1]);	//linker Oberarm
					e.Graphics.DrawLine(mypenBlack, (float)_Association.Model2D[9,0],  (float)_Association.Model2D[9,1],  (float)_Association.Model2D[1,0],  (float)_Association.Model2D[1,1]);	//Schulter
					e.Graphics.DrawLine(mypenBlack, (float)_Association.Model2D[1,0],  (float)_Association.Model2D[1,1],  (float)_Association.Model2D[10,0], (float)_Association.Model2D[10,1]);//rechter Oberarm
					e.Graphics.DrawLine(mypenBlack, (float)_Association.Model2D[10,0], (float)_Association.Model2D[10,1], (float)_Association.Model2D[5,0],  (float)_Association.Model2D[5,1]);	//rechter Unterarm
					e.Graphics.DrawLine(mypenBlack, (float)_Association.Model2D[9,0],  (float)_Association.Model2D[9,1],  (float)_Association.Model2D[11,0], (float)_Association.Model2D[11,1]);//linke Seite
					e.Graphics.DrawLine(mypenBlack, (float)_Association.Model2D[1,0],  (float)_Association.Model2D[1,1],  (float)_Association.Model2D[2,0],  (float)_Association.Model2D[2,1]);	//rechte Seite
					e.Graphics.DrawLine(mypenBlack, (float)_Association.Model2D[11,0], (float)_Association.Model2D[11,1], (float)_Association.Model2D[2,0],  (float)_Association.Model2D[2,1]);	//Hfte
					e.Graphics.DrawLine(mypenBlack, (float)_Association.Model2D[11,0], (float)_Association.Model2D[11,1], (float)_Association.Model2D[6,0],  (float)_Association.Model2D[6,1]);	//linker Oberschenkel
					e.Graphics.DrawLine(mypenBlack, (float)_Association.Model2D[2,0],  (float)_Association.Model2D[2,1],  (float)_Association.Model2D[12,0], (float)_Association.Model2D[12,1]);//rechter Oberschenkel
					e.Graphics.DrawLine(mypenBlack, (float)_Association.Model2D[6,0],  (float)_Association.Model2D[6,1],  (float)_Association.Model2D[3,0],  (float)_Association.Model2D[3,1]);	//linker Unterschenkel
					e.Graphics.DrawLine(mypenBlack, (float)_Association.Model2D[12,0], (float)_Association.Model2D[12,1], (float)_Association.Model2D[7,0],  (float)_Association.Model2D[7,1]);	//rechter Unterschenkel
					e.Graphics.DrawLine(mypenBlack, (float)_Association.Model2D[8,0],  (float)_Association.Model2D[8,1],  (float)_Association.Model2D[13,0], (float)_Association.Model2D[13,1]);//Hals					

					for (int j=0; j<=3; j++)
					{
						e.Graphics.DrawEllipse(mypenRed, (float)(_Association.Model2D[j,0]-6), (float)(_Association.Model2D[j,1]-6), 12, 12);
					}
					for (int j=4; j<=7; j++)
					{
						e.Graphics.DrawEllipse(mypenBlue, (float)(_Association.Model2D[j,0]-6), (float)(_Association.Model2D[j,1]-6), 12, 12);
					}
					for (int j=8; j<=12; j++)
					{
						e.Graphics.DrawEllipse(mypenGreen, (float)(_Association.Model2D[j,0]-6), (float)(_Association.Model2D[j,1]-6), 12, 12);
					}
				}

				// Featurepoints
				foreach (FeaturePoint p in _Association.lastFrame.Pred.Values)
				{
					e.Graphics.FillEllipse(mybrushRed, p.X-6, p.Y-6, 12, 12);
				}

				foreach (FeaturePoint p in _Association.lastFrame.Pblue.Values)
				{
					e.Graphics.FillEllipse(mybrushBlue, p.X-6, p.Y-6, 12, 12);
				}

				foreach (FeaturePoint p in _Association.lastFrame.Pgreen.Values)
				{
					e.Graphics.FillEllipse(mybrushGreen, p.X-6, p.Y-6, 12, 12);
				}

				// Assoziationsergebnisse
				int i=0;
				int k=0;
				foreach (clsClient Client in _Association.ClientCollection.Values)
				{
					if ( Client.Host.Equals(_client) )
					{
						k=i;
					}
					i++;
				}
				if(_Association.FPs!=null)
				{
					for (i=0; i<13; i++)
					{
						if(_Association.FPs[i][k]!=null && _Association.Model2D[i,0]!=0)
							e.Graphics.DrawLine(mypenPink, (float)_Association.FPs[i][k].X, (float)_Association.FPs[i][k].Y, (float)_Association.Model2D[i,0],  (float)_Association.Model2D[i,1]);
					}
				}
			
			}
			catch{}
		}

		private void nUD_Size_ValueChanged(object sender, System.EventArgs e)
		{
			_Association.Size = (float)nUD_Size.Value;
			_Association.Resize3Dmodel();
			this.Refresh();
		}

		private void btn_Associate_Click(object sender, System.EventArgs e)
		{
			_Association.Associate();
			this.Refresh();
		}

		private void lbox_Client_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			System.Console.WriteLine(lbox_Client.SelectedItem.ToString());
			_client = lbox_Client.SelectedItem.ToString();
			_Association.Resize3Dmodel(lbox_Client.SelectedItem.ToString());
			this.Refresh();
		}

		private void btn_nextFrame_Click(object sender, System.EventArgs e)
		{
			_Association.nextFrame();
		}

		private void btn_Sync_Click(object sender, System.EventArgs e)
		{
			_BroadcastServer.Send(new clsNetSyncSignal("",_signal++));
		}
	}
}
