using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace MTServer
{
	/// <summary>
	/// Zusammenfassung fr uscClientCollector.
	/// </summary>
	public class uscClientCollector : System.Windows.Forms.UserControl
	{
		private delegate void NewClientSaveDelegate(string conID,clsClientStatus clientStatus);
		private delegate void ClientDisconnectSaveDelegate(string conID);

		//private uscClientStatus _uscClientStatus;
		private int _height = 0;

		private Hashtable	_ConnectedClients = new Hashtable();
		/// <summary> 
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public uscClientCollector()
		{
			// Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
			InitializeComponent();

			// TODO: Initialisierungen nach dem Aufruf von InitializeComponent hinzufgen

		}

		/// <summary> 
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Komponenten-Designer generierter Code
		/// <summary> 
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
		}
		#endregion

		public void Initialize(clsClientCollector clientCollector)
		{
	
			clientCollector.NewClient += new clsClientCollector.NewClientConnectDelegate(_ClientCollector_NewClient);
			clientCollector.ClientDisconnect += new clsClientCollector.ClientDisconnectDelegate(_ClientCollector_ClientDisconnect);

		}


		private void CreateNewClientControl(string conID, clsClientStatus clientStatus)
		{
			uscClientStatus uClientStatus = new uscClientStatus();
			uClientStatus.Initialize(clientStatus);

			this.SuspendLayout();
			int height = 80;

			// 
			// uscClientStatus1
			// 
			uClientStatus.Location = new System.Drawing.Point(0, _height);
			_height += height;
			uClientStatus.Name = "uscClientStatus" + conID;
			uClientStatus.Size = new System.Drawing.Size(760, height);
			uClientStatus.TabIndex = 0;
			// 
			// uscClientCollector
			// 
			this.Controls.Add(uClientStatus);
			this._ConnectedClients.Add(uClientStatus.Name,uClientStatus);
			this.Name = "uscClientCollector";
			this.Size = new System.Drawing.Size(816, 296);
			this.ResumeLayout(false);


		}


		private void _ClientCollector_NewClient(string conID, clsClientStatus clientStatus)
		{
			this.Invoke(new NewClientSaveDelegate(CreateNewClientControl),new Object[] {conID, clientStatus});
			
		}

		private void DeleteClientControl(string conID)
		{
			uscClientStatus uClientStatus = this._ConnectedClients["uscClientStatus" + conID] as uscClientStatus;
			if (uClientStatus!= null)
			{
				this.Controls.Remove(uClientStatus);
				uClientStatus.Dispose();
				this._ConnectedClients.Clear();
			}
			MessageBox.Show("Disconnect" + conID);

		}
		private void _ClientCollector_ClientDisconnect(string conID)
		{
			this.Invoke(new ClientDisconnectSaveDelegate(DeleteClientControl),new Object[] {conID});
		}
		
	}
}
